--SR3 City Lua file for Sandbox+


-- *** SUPERPOWERS WEAPON SLOT DISABLE SETTINGS
-- SUPERPOWER_SLOT_DISABLE = true (default) Weapon switching is slightly buggy so disabled by default
-- SUPERPOWER_SLOT_DISABLE = false enables you to use all your weapon slots when superpowers activated
SUPERPOWER_SLOT_DISABLE = true


-- *** TIME OF DAY AUTOMATIC TRANSITION SETTINGS ***
-- TOD_THREAD_ON = 1 (default) allows automatic time of day transitions for Sandbox+
-- TOD_THREAD_ON = 0 turns off automatic time of day transitions just like vanilla (tod only changes after missions/load)
TOD_THREAD_ON = 1


-- *** TUTORIAL DISABLE SETTINGS ***
-- TUTORIAL_DISABLE = true (default) disables all open world tutorial messages (does not affect missions)
-- TUTORIAL_DISABLE = false allows tutorial popups to happen in the open world just like normal vanilla
TUTORIAL_DISABLE = true


-- *** POLICE SHOOT FROM VEHICLES AT NOTORIETY 3 OR HIGHER NOTE: THIS ONLY AFFECTS OPEN WORLD AND NOT MISSIONS/ACTIVITIES! ***
-- POLICE_SHOOT_FROM_VEHICLES = true (default) allows cops to start shooting at you from their vehicles at notoriety 3 or higher
-- POLICE_SHOOT_FROM_VEHICLES = false prevents them from shooting at you from their cars. This is the original behavior of the vanilla game
POLICE_SHOOT_FROM_VEHICLES = true


-- *** ON-FOOT RADIO RANDOMIZE SETTINGS ***
-- randomize_music = "off" (default) has all on-foot radio play in the order you see them below in the RadioData table
-- randomize_music = "on" forces all on-foot radio to auto shuffle on load
local randomize_music = "off"


-- ** ON-FOOT MIXTAPE PLAYLIST TRACK SETTINGS ***
-- NOTE: This applies to each entry in the following RadioData table; including songs, commercials, newscasts, etc
-- mixtape = true  will add the track to your on-foot Custom Playlist
-- mixtape = false (default) will exclude that track from your on-foot custom playlist


local RadioData =
{
	-- THE MIXX
	{ mixtape = false	,SongString = "Adam Ant - Stand and Deliver",					SongData = "MIX_ADAM_ANT___STAND_AND_DELIVER",				station = "MIXX" },
	{ mixtape = false	,SongString = "Aldo Nova - Fantasy",						SongData = "MIX_ALDO_NOVA___FANTASY",					station = "MIXX" },
	{ mixtape = false	,SongString = "Bonnie Tyler - Holding out for a Hero",				SongData = "MIX_BONNIE_TYLER___HOLDING_OUT_FOR_A_HERO",			station = "MIXX" },
	{ mixtape = false	,SongString = "Bush - Machinehead",						SongData = "MIX_BUSH___MACHINEHEAD",					station = "MIXX" },
	{ mixtape = false	,SongString = "The Butthole Surfers - Pepper",					SongData = "MIX_BUTTHOLE_SURFERS___PEPPER",				station = "MIXX" },
	{ mixtape = false	,SongString = "Faith no More - Epic",						SongData = "MIX_FAITH_NO_MORE___EPIC",					station = "MIXX" },
	{ mixtape = false	,SongString = "Frankie Goes to Hollywood - Relax",				SongData = "MIX_FRANKIE_GOES_TO_HOLLYWOOD___RELAX",			station = "MIXX" },
	{ mixtape = false	,SongString = "The Icicle Works - Birds Fly Whisper to a Scream",		SongData = "MIX_THE_ICICLE_WORKS___BIRDS_FLY_WHISPER_TO_A_SCREAM",	station = "MIXX" },
	{ mixtape = false	,SongString = "Joe Esposito - You're the Best Around",				SongData = "MIX_JOE_BEAN_ESPOSITO___YOURE_THE_BEST",			station = "MIXX" },
	{ mixtape = false	,SongString = "Mark Morrison - Return of the Mack",				SongData = "MIX_MARK_MORRISON___RETURN_OF_THE_MACK",			station = "MIXX" },
	{ mixtape = false	,SongString = "Motley Crue - Live Wire",					SongData = "MIX_MOTLEY_CRUE___LIVE_WIRE",				station = "MIXX" },
	{ mixtape = false	,SongString = "Motley Crue - Shout at the Devil",				SongData = "MIX_MOTLEY_CRUE___SHOUT_AT_THE_DEVIL",			station = "MIXX" },
	{ mixtape = false	,SongString = "Robert Tepper - No Easy Way Out",				SongData = "MIX_ROBERT_TEPPER___NO_EASY_WAY_OUT",			station = "MIXX" },
	{ mixtape = false	,SongString = "Run DMC - My Adidas",						SongData = "MIX_RUN_DMC___MY_ADIDAS",					station = "MIXX" },
	{ mixtape = false	,SongString = "Social Distortion - Ball and Chain",				SongData = "MIX_SOCIAL_DISTORTION___BALL_AND_CHAIN",			station = "MIXX" },
	{ mixtape = false	,SongString = "Sublime - What I Got",						SongData = "MIX_SUBLIME___WHAT_I_GOT",					station = "MIXX" },
	{ mixtape = false	,SongString = "Talk Talk - It's My Life",					SongData = "MIX_TALK_TALK___ITS_MY_LIFE",				station = "MIXX" },
	{ mixtape = false	,SongString = "Tone Loc - Funky Cold Medina",					SongData = "MIX_TONE_LOC___FUNKY_COLD_MEDINA",				station = "MIXX" },

	-- K12
	{ mixtape = false	,SongString = "Baobinga - State of Ghetto Jackin feat. DJ Nasty",		SongData = "K12_BAOBINGA___STATE_OF_GHETTO_JACKIN",			station = "K12" },
	{ mixtape = false	,SongString = "Benny Benassi - Satisfaction",					SongData = "K12_BENNY_BENASSI___SATISFACTION",				station = "K12" },
	{ mixtape = false	,SongString = "The Bloody Beetroots - 31 Seconds To Die",			SongData = "K12_THE_BLOODY_BEETROOTS___31_SECONDS_TO_DIE",		station = "K12" },
	{ mixtape = false	,SongString = "Deadmau5 - A City in Florida",					SongData = "K12_DEADMAU5___A_CITY_IN_FLORIDA",				station = "K12" },
	{ mixtape = false	,SongString = "Digitalism - Idealistic",					SongData = "K12_DIGITALISM___IDEALISTIC",				station = "K12" },
	{ mixtape = false	,SongString = "Dilemn - Pitiless",						SongData = "K12_DILEMN___PITILESS",					station = "K12" },
	{ mixtape = false	,SongString = "Divalola - Wallflower",						SongData = "K12_KEVIN_AND_CARRICK___WALLFLOWERS",			station = "K12" },
	{ mixtape = false	,SongString = "Grum - Heartbeats",						SongData = "K12_GRUM___HEARTBEATS",					station = "K12" },
	{ mixtape = false	,SongString = "Jesse No - Double Bubble",					SongData = "K12_JESSE_NO___DOUBLE_BUBBLE",				station = "K12" },
	{ mixtape = false	,SongString = "Jesse No - OH NO U DON'T",					SongData = "K12_JESSE_NO___OH_NO_U_DONT",				station = "K12" },
	{ mixtape = false	,SongString = "Jokers of the Scene - Baggy Bottom Boys",			SongData = "K12_BAGGY_BOTTOM_BOYS___JOKERS_ON_THE_SCENE",		station = "K12" },
	{ mixtape = false	,SongString = "Junkie XL - Angry Elephants",					SongData = "K12_JUNKIE_XL___ANGRY_ELEPHANTS",				station = "K12" },
	{ mixtape = false	,SongString = "Kevin Seaton - Scrub Down",					SongData = "K12_KEVIN_SEATON___SCRUB_DOWN",				station = "K12" },
	{ mixtape = false	,SongString = "MNDR - C.L.U.B.",						SongData = "K12_MNDR___C_L_U_B",					station = "K12" },
	{ mixtape = false	,SongString = "Ratatat - Neckbrace",						SongData = "K12_RATATAT___NECKBRACE",					station = "K12" },
	{ mixtape = false	,SongString = "Rusko - Woo Boost",						SongData = "K12_RUSKO___WOO_BOOST",					station = "K12" },
	{ mixtape = false	,SongString = "Tugboat - Don't Break It",					SongData = "K12_TUGBOAT___DONT_BREAK_IT",				station = "K12" },

	-- BLOOD
	{ mixtape = false	,SongString = "After the Burial - Berzerker",					SongData = "KRUNCH_AFTER_THE_BURIAL___BEZERKER",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Amon Amarth - Runes To My Memory",				SongData = "KRUNCH_AMON_AMARTH___RUNES_TO_MY_MEMORY",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Between the Buried and Me - Obfuscation",			SongData = "KRUNCH_BETWEEN_THE_BURIED_AND_ME___OBFUSCATION",		station = "KRUNCH" },
	{ mixtape = false	,SongString = "The Black Dahlia Murder - Necropolis",				SongData = "KRUNCH_THE_BLACK_DAHLIA_MURDER___NECROPOLIS",		station = "KRUNCH" },
	{ mixtape = false	,SongString = "Black Veil Brides - Perfect Weapon",				SongData = "KRUNCH_BLACK_VEIL_BRIDES___PERFECT_WEAPON",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Chemlab - Suicide Jag",						SongData = "KRUNCH_CHEMLAB___SUICIDE_JAG",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "The Dillinger Escape Plan - Farewell, Mona Lisa",		SongData = "KRUNCH_THE_DILLINGER_ESCAPE_PLAN___FAREWELL_MONA_LISA",	station = "KRUNCH" },
	{ mixtape = false	,SongString = "Drowning Pool - Feel Like I Do",					SongData = "KRUNCH_DROWNING_POOL___FEEL_LIKE_I_DO",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Goatwhore - Apocalyptic Havoc",					SongData = "KRUNCH_GOATWHORE___APOCALYPTIC_HAVOC",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Job for a Cowboy - Regurgitated Disinformation",			SongData = "KRUNCH_JOB_FOR_A_COWBOY___REGURGITATED_DISINFORMATION",	station = "KRUNCH" },
	{ mixtape = false	,SongString = "KMFDM - WWIII",							SongData = "KRUNCH_KMFDM___WWIII",					station = "KRUNCH" },
	{ mixtape = false	,SongString = "Marilyn Manson - Arma-Goddamn-Motherfuckin-Geddon",		SongData = "KRUNCH_MARYLIN_MANSON___ARMAGODDAMNMOTHERFUCKINGGEDDON",	station = "KRUNCH" },
	{ mixtape = false	,SongString = "Mastodon - Divinations",						SongData = "KRUNCH_MASTODON___DIVINATIONS",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Miss May I - Apologies Are for the Weak",			SongData = "KRUNCH_MISS_MAY_I___APOLOGIES_ARE_FOR_THE_WEAK",		station = "KRUNCH" },
	{ mixtape = false	,SongString = "Opeth - The Lotus Eater",					SongData = "KRUNCH_OPETH___THE_LOTUS_EATERS",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Otep - Rise, Rebel, Resist",					SongData = "KRUNCH_OTEP___RISE_REBEL_RESIST",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Shai Hulud - Misanthropy Pure",					SongData = "KRUNCH_SHAI_HULUD___MISANTHROPY_PURE",			station = "KRUNCH" },
	{ mixtape = false	,SongString = "Strapping Young Lad - Love?",					SongData = "KRUNCH_STRAPPING_YOUNG_LAD___LOVE",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "Tugboat - Slow Revolution",					SongData = "KRUNCH_TUGBOAT___SLOW_REVOLUTION",				station = "KRUNCH" },
	{ mixtape = false	,SongString = "You Love Her Coz She's Dead - Engine Wrecker",			SongData = "KRUNCH_YOU_LOVE_HER_COZ_SHES_DEAD___ENGINE_WRECKS",		station = "KRUNCH" },

	-- KLASSIC
	{ mixtape = false	,SongString = "Bach  Brandenburg Concerto No. 3 Allegro",			SongData = "KLASSIC_BACH___BRANDENBURG_CONCERTO_NO_3_ALLEGRO",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Boccherini  Minuet",						SongData = "KLASSIC_BOCCHERINI___MINUET",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Chopin  Waltz in D Flat Major Op 64 No 1",			SongData = "KLASSIC_CHOPIN___WALTZ_IN_D_FLAT_MAJOR",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Dvorak  Humoresque Op 101 No 7",				SongData = "KLASSIC_DVORAK___HUMORESQUE_OP_101_NO_7",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Handel - Hallelujah from Messiah",				SongData = "KLASSIC_HANDEL___HALLELUJAH_FROM_MESSIAH",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Liszt - Hungarian Rhapsody No. 2",				SongData = "KLASSIC_LISZT___HUNGARIAN_RHAPSODY",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mendelssohn - Spring Song",					SongData = "KLASSIC_MENDELSSOHN___SPRING_SONG",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mozart - The Magic Flute: Der Holle Rache",			SongData = "KLASSIC_MOZART___DER_HOLLE_RACHE",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mozart - Eine Kleine Nachtmusik: Serenade No 13 in G, Allegro",	SongData = "KLASSIC_MOZART___SERENADE_NO_13_IN_G_ALLEGRO",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Mozart - Eine Kleine Nachtmusik: Serenade No 13 in G, Rondo",	SongData = "KLASSIC_MOZART___SERENADE_NO_13_IN_G_RONDO",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Rossini - The Thieving Magpie Overture",				SongData = "KLASSIC_ROSSINI___THE_THIEVING_MAGPIE_OVERTURE",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Rossini - William Tell Overture",				SongData = "KLASSIC_ROSSINI___THE_WILLIAM_TELL_OVERTURE",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Saint-Saens - Carnival of Animals: The Fossils",			SongData = "KLASSIC_SAINT_SAENS___CARNIVAL_OF_THE_ANIMALS_THE_FOSSILS",	station = "KLASSIC" },
	{ mixtape = false	,SongString = "Sousa - Stars and Stripes",					SongData = "KLASSIC_SOUSA___THE_STARS_AND_STRIPES_FOREVER",		station = "KLASSIC" },
	{ mixtape = false	,SongString = "Strauss - Blue Danube",						SongData = "KLASSIC_STRAUSS___BLUE_DANUBE",				station = "KLASSIC" },
	{ mixtape = false	,SongString = "Wagner - Ride of the Valkyries",					SongData = "KLASSIC_WAGNER___RIDE_OF_THE_VALKYRIES",			station = "KLASSIC" },
	{ mixtape = false	,SongString = "Waldteufel - Skaters Waltz",					SongData = "KLASSIC_WALDTEUFEL___SKATERS_WALTZ",			station = "KLASSIC" },

	-- ADULT SWIM
	{ mixtape = false	,SongString = "Black Mountain - Let Spirits Ride",				SongData = "SWIM_BLACK_MOUNTAIN___LET_SPIRITS_RIDE",			station = "SWIM" },
	{ mixtape = false	,SongString = "Cerebral Ballzy - Insufficient Fare",				SongData = "SWIM_CEREBRAL_BALLZY___INSUFFICIENT_FAIR",			station = "SWIM" },
	{ mixtape = false	,SongString = "Cheeseburger - Winner",						SongData = "SWIM_CHEESEBURGER___WINNER",				station = "SWIM" },
	{ mixtape = false	,SongString = "Danger Doom - Basketcase",					SongData = "SWIM_DANGERDOOM___BASKET_CASE",				station = "SWIM" },
	{ mixtape = false	,SongString = "Dethklok - The Cyborg Slayers",					SongData = "SWIM_DETHKLOK___THE_CYBORG_SLAYERS",			station = "SWIM" },
	{ mixtape = false	,SongString = "J.G. Thirlwell - No Vacancy",					SongData = "SWIM_J_G_THIRLWELL___NO_VACANCY",				station = "SWIM" },
	{ mixtape = false	,SongString = "Mike Bigga - The War",						SongData = "SWIM_MIKE_BIGGA___THE_WAR",					station = "SWIM" },
	{ mixtape = false	,SongString = "OFWGKTA - Anarchy",						SongData = "SWIM_ODD_FUTURE___ANARCHY",					station = "SWIM" },
	{ mixtape = false	,SongString = "Schooly D - Aqua Teen Hunger Force Theme (Remix)",		SongData = "SWIM_SCHOOLY_D___ATHF_THEME_REMIX",				station = "SWIM" },
	{ mixtape = false	,SongString = "Tim & Eric - Sports (Sports Bar Remix)",				SongData = "SWIM_TIM_AND_ERIC___SPORTS_SPORTS_BAR_REMIX",		station = "SWIM" },
	{ mixtape = false	,SongString = "Unknown Hinson - Save Me From Myself",				SongData = "SWIM_UNKNOWN_HINSON___SAVE_ME_FROM_MYSELF",			station = "SWIM" },
	{ mixtape = false	,SongString = "Wavves - Idiot",							SongData = "SWIM_WAVVES___IDIOT",					station = "SWIM" },

	-- KABRON
	{ mixtape = false	,SongString = "Ambush - Este Reggaeton",					SongData = "KABRON_AMBUSH___ESTE_REGGAETON",				station = "KABRON" },
	{ mixtape = false	,SongString = "Blaster Chicks - Vamonos Hasta Bajo",				SongData = "KABRON_BLASTER_CHICKS___VAMONOS_HASTA_BAJO",		station = "KABRON" },
	{ mixtape = false	,SongString = "Calle Cardona - Get Down",					SongData = "KABRON_CALLE_CARDONA___GET_DOWN",				station = "KABRON" },
	{ mixtape = false	,SongString = "DJ Genesis feat. Shimola - Ella Prenda Gilla",			SongData = "KABRON_DJ_GENESIS___ELLA_PRENDE_GILLA",			station = "KABRON" },
	{ mixtape = false	,SongString = "Don Omar - Virtual Diva",					SongData = "KABRON_DON_OMAR___VIRTUAL_DIVA",				station = "KABRON" },
	{ mixtape = false	,SongString = "FDK - Lujo",							SongData = "KABRON_FDK___LUJO",						station = "KABRON" },
	{ mixtape = false	,SongString = "FDK feat. Pinky - Dejate Llevar",				SongData = "KABRON_FDK_FEAT_PINKY___DEJATE_LLEVAR",			station = "KABRON" },
	{ mixtape = false	,SongString = "Flama - Movimiento Espectacular",				SongData = "KABRON_FLAMA___MOVIMIENTO_ESPECTACULAR",			station = "KABRON" },
	{ mixtape = false	,SongString = "Chacka feat. Kanelo - Friendz",					SongData = "KABRON_FRIENDZ___CHACKA",					station = "KABRON" },
	{ mixtape = false	,SongString = "Mr. Kapri - Maria Juana",					SongData = "KABRON_MR_KAPRI___MARIA_JUANA",				station = "KABRON" },
	{ mixtape = false	,SongString = "Pitbull - Maldito Alcohol",					SongData = "KABRON_PITBULL___MALDITO_ALCOHOL",				station = "KABRON" },
	{ mixtape = false	,SongString = "Prophex - La Turbina",						SongData = "KABRON_PROPHEX___LA_TURBINA",				station = "KABRON" },
	{ mixtape = false	,SongString = "MR-1 and Phophex - Sue Fue La Luz",				SongData = "KABRON_R_1___SE_FUE_LA_LUZ",				station = "KABRON" },
	{ mixtape = false	,SongString = "Reggae Black - Sueltate y Toma",					SongData = "KABRON_REGGAE_BLACK___SUELTATE_Y_TOMA",			station = "KABRON" },
	{ mixtape = false	,SongString = "Vakero - Ponte A Trabajar",					SongData = "KABRON_VAKERO___PONTE_A_TRABAJAR",				station = "KABRON" },
	{ mixtape = false	,SongString = "Villanmosam - Todavia no hay na",				SongData = "KABRON_VILLANMOSAM___TODAVIA_NO_HAY_NA",			station = "KABRON" },

	-- KRHYME
	{ mixtape = false	,SongString = "Amanda Blank - Gimme What You Got",				SongData = "KRHYME_AMANDA_BLANK___GIMME_WHAT_YOU_GOT",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Blakroc - Done Did It feat. Nicole Wray & NOE",			SongData = "KRHYME_BLAKROC___DONE_DID_IT",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Freeway - Throw Your Hands Up",					SongData = "KRHYME_FREEWAY___THROW_YOUR_HANDS_UP",			station = "KRHYME" },
	{ mixtape = false	,SongString = "G-Eazy - My Life Is A Party",					SongData = "KRHYME_G_EASY___MY_LIFE_IS_A_PARTY",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Kanye West - Power",						SongData = "KRHYME_KANYE_WEST___POWER",					station = "KRHYME" },
	{ mixtape = false	,SongString = "KB - Get It In feat. Ammo & K. Madison",				SongData = "KRHYME_KB___GET_IT_IN",					station = "KRHYME" },
	{ mixtape = false	,SongString = "Kurupt - I'm Burnt feat. Problem",				SongData = "KRHYME_KURUPT___IM_BURNT",					station = "KRHYME" },
	{ mixtape = false	,SongString = "Medine - Don't Panik",						SongData = "KRHYME_MEDINE___DONT_PANIK",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Mickey Factz - Paradise",					SongData = "KRHYME_MICKEY_FACTZ___PARADISE",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Mos Def - Quiet Dog",						SongData = "KRHYME_MOS_DEF___QUIET_DOG",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Pharoahe Monch - In The Zone",					SongData = "KRHYME_PHAROAHE_MONCH___IN_THE_ZONE",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Rob Roy - Fur In My Cap",					SongData = "KRHYME_ROB_ROY___FUR_IN_MY_CAP",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Sean Price - Boom Bye Yeah",					SongData = "KRHYME_SEAN_PRICE___BOOM_BYE_YEAH",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Sixx John - Push Play",						SongData = "KRHYME_SIXX_JOHN___PUSH_PLAY",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Southpaw Swagger - Can't Stop Now",				SongData = "KRHYME_SOUTHPAW_SWAGGER___CANT_STOP_NOW",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Sum Kid - The Countdown",					SongData = "KRHYME_SUM_KID___THE_COUNTDOWN",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Tandem - 93 Hardcore",						SongData = "KRHYME_TANDEM___93_HARDCORE",				station = "KRHYME" },
	{ mixtape = false	,SongString = "Tyler, The Creator - Yonkers",					SongData = "KRHYME_TYLER_THE_CREATOR___YONKERS",			station = "KRHYME" },
	{ mixtape = false	,SongString = "Wale - Mirrors feat. Bun B",					SongData = "KRHYME_WALE___MIRRORS",					station = "KRHYME" },
	{ mixtape = false	,SongString = "Yelawolf - Good to Go feat. Bun B",				SongData = "KRHYME_YELAWOLF___GOOD_TO_GO",				station = "KRHYME" },

	-- GENX
	{ mixtape = false	,SongString = "The Black Keys - Next Girl",					SongData = "GENX_THE_BLACK_KEYS___NEXT_GIRL",				station = "GENX" },
	{ mixtape = false	,SongString = "Brooklyn - Volcanology",						SongData = "GENX_BROOKLYN___VOLCANOLOGY",				station = "GENX" },
	{ mixtape = false	,SongString = "The Dear Hunter - In Cauda Venenum",				SongData = "GENX_THE_DEAR_HUNTER___IN_CAUDA_VENENUM",			station = "GENX" },
	{ mixtape = false	,SongString = "Deftones - Diamond Eyes",					SongData = "GENX_DEFTONES___DIAMOND_EYES",				station = "GENX" },
	{ mixtape = false	,SongString = "Delphic - Clarion Call",						SongData = "GENX_DELPHIC___CLARION_CALL",				station = "GENX" },
	{ mixtape = false	,SongString = "The Do - Queen Dot Kong",					SongData = "GENX_THE_DO___QUEEN_DOT_KONG",				station = "GENX" },
	{ mixtape = false	,SongString = "Dragonette - Stupid Grin",					SongData = "GENX_DRAGONETTE___STUPID_GRIN",				station = "GENX" },
	{ mixtape = false	,SongString = "Feeder - Renegades",						SongData = "GENX_FEEDER___RENEGADES",					station = "GENX" },
	{ mixtape = false	,SongString = "Heavy Young Heathens - Sha La La La La",				SongData = "GENX_HEAVY_YOUNG_HEATHENS___SHA_LA_LA_LA_LA",		station = "GENX" },
	{ mixtape = false	,SongString = "Hockey - Too Fake",						SongData = "GENX_HOCKEY___TOO_FAKE",					station = "GENX" },
	{ mixtape = false	,SongString = "JR - Lost Desire",						SongData = "GENX_JR___LOST_DESIRE",					station = "GENX" },
	{ mixtape = false	,SongString = "King Khan and the Shrines - Torture",				SongData = "GENX_KING_KHAN_AND_THE_SHRINES___TORTURE",			station = "GENX" },
	{ mixtape = false	,SongString = "The Lines - El Matador",						SongData = "GENX_THE_LINES___EL_MATADOR",				station = "GENX" },
	{ mixtape = false	,SongString = "Miike Snow - Animal",						SongData = "GENX_MIIKE_SNOW___ANIMAL",					station = "GENX" },
	{ mixtape = false	,SongString = "The Rassle - Born Free",						SongData = "GENX_THE_RASSLE___BORN_FREE",				station = "GENX" },
	{ mixtape = false	,SongString = "Sleigh Bells - Riot Rhythm",					SongData = "GENX_SLEIGH_BELLS___RIOT_RHYTHM",				station = "GENX" },
	{ mixtape = false	,SongString = "Valencia - Stop Searching",					SongData = "GENX_VALENCIA___STOP_SEARCHING",				station = "GENX" },
	{ mixtape = false	,SongString = "White Denim - Paint Yourself",					SongData = "GENX_WHITE_DENIM___PAINT_YOURSELF",				station = "GENX" },

	-- COMMERICALS
	{ mixtape = true	,SongString = "3 Count Casino Commercial 1",					SongData = "COMMERCIAL_3COUNT_CASINO",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "3 Count Casino Commercial 2",					SongData = "COMMERCIAL_3COUNT_CASINO_PITBOSS",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Aisha Commercial",						SongData = "COMMERCIAL_AISHA",						station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Be a Saint Commercial",						SongData = "COMMERCIAL_BE_A_SAINT",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Beyond the Mask Commercial",					SongData = "COMMERCIAL_BEYOND_THE_MASK",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Broken Shillelagh Commercial",					SongData = "COMMERCIAL_BROKEN_SHILLELAGH",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Cement Shoes Commercial",					SongData = "COMMERCIAL_CEMENT_SHOES_THE_MUSICAL_SPOT",			station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Demasking Angel Commercial",					SongData = "COMMERCIAL_DEMASKING_ANGEL",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Dragons and Tears Commercial",					SongData = "COMMERCIAL_DRAGONS_AND_TEARS",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Eric Gryphon Interview Comercial",				SongData = "COMMERCIAL_ERIC_GORPHAN_INTERVIEW",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Feelboss Commercial",						SongData = "COMMERCIAL_FEELBOSS",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Friendly Fire Commercial",					SongData = "COMMERCIAL_FRIENDLY_FIRE",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Gangsters in Space Commercial",					SongData = "COMMERCIAL_GANGSTERS_SPACE",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Professor Genki Mall Commercial",				SongData = "COMMERCIAL_GENKI_MALL_APPEARANCE",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Professor Genki Reality Climax Commercial",			SongData = "COMMERCIAL_GENKI_REALITY_CLIMAX",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Professor Genki World Commercial",				SongData = "COMMERCIAL_GENKI_WORLD",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Josh Birk Special Commercial",					SongData = "COMMERCIAL_JOSH_BIRK_SPECIAL",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Kitty Style Commercial",						SongData = "COMMERCIAL_KITTY_STYLE",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Let's Pretend Commercial",					SongData = "COMMERCIAL_LETS_PRETEND",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Lowdown Conspiracy Commercial",					SongData = "COMMERCIAL_LOWDOWN_CONSPIRACY",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Lowdown Online Addiction Commercial",				SongData = "COMMERCIAL_LOWDOWN_ONLINE_ADDICTION",			station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Lowdown Phillipe Commerical",					SongData = "COMMERCIAL_LOWDOWN_PHILLIPE",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Lowdown Sex Trade Commercial",					SongData = "COMMERCIAL_LOWDOWN_SEX_TRADE",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 1",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_1",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 2",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_2",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 3",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_3",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 4",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_4",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Mayor Reynolds Commercial 5",					SongData = "COMMERCIAL_MAYOR_REYNOLDS_5",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Murderbrawl XXXI Commercial 1",					SongData = "COMMERCIAL_MURDERBRAWL_31",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Murderbrawl XXXI Commercial 2",					SongData = "COMMERCIAL_MURDERBRAWL31",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nobody Loves Me Commercial",					SongData = "COMMERCIAL_NOBODY_LOVES_ME",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Planet Saints Commercial",					SongData = "COMMERCIAL_PLANET_SAINTS_JINGLE_2",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Powder Room Commercial",						SongData = "COMMERCIAL_POWDER",						station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "PSA Boots Commercial",						SongData = "COMMERCIAL_PSA_BOOTS",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "PSA Brass Knuckles Commercial",					SongData = "COMMERCIAL_PSA_BRASS_KNUCKLES",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "PSA Cologne Commercial",						SongData = "COMMERCIAL_PSA_COLOGNE",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "PSA Condoms Commercial",						SongData = "COMMERCIAL_PSA_CONDOMS",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "PSA Men's Suits Commercial",					SongData = "COMMERCIAL_PSA_MENS_SUITS",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Regicide Commercial",						SongData = "COMMERCIAL_REGICIDE",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Rim Jobs Commercial",						SongData = "COMMERCIAL_RIM_JOBS",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Safe Word Commercial",						SongData = "COMMERCIAL_SAFE_WORD",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Saints Flow Commercial",						SongData = "COMMERCIAL_SAINTS_FLOW_DRINK",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Sleep with Shaundi Commercial",					SongData = "COMMERCIAL_SLEEP_WITH_SHAUNDI",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "STAG Cyrus Temple Commercial",					SongData = "COMMERCIAL_STAG_CYRUS_TEMPLE",				station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "STAG Josh Birk Commercial",					SongData = "COMMERCIAL_STAG_JOSH_BIRK",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "STAG Welcome Commercial",					SongData = "COMMERCIAL_STAG_WELCOME",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Steelport Commercial",						SongData = "COMMERCIAL_STEELPORT_30",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Ultor Commercial",						SongData = "COMMERCIAL_ULTOR_VOICE",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Jane Valdorama Commercial",					SongData = "COMMERCIAL_VALDORAMA",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 1",					SongData = "COMMERCIAL_NIGHTBLADE_01",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 2",					SongData = "COMMERCIAL_NIGHTBLADE_02",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 3",					SongData = "COMMERCIAL_NIGHTBLADE_03",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 4",					SongData = "COMMERCIAL_NIGHTBLADE_04",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 5",					SongData = "COMMERCIAL_NIGHTBLADE_05",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 6",					SongData = "COMMERCIAL_NIGHTBLADE_06",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 7",					SongData = "COMMERCIAL_NIGHTBLADE_07",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 8",					SongData = "COMMERCIAL_NIGHTBLADE_08",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 9",					SongData = "COMMERCIAL_NIGHTBLADE_09",					station = "COMMERCIAL" },
	{ mixtape = false	,SongString = "Nightblade Commercial 10",					SongData = "COMMERCIAL_NIGHTBLADE_10",					station = "COMMERCIAL" },

	-- NEWSBREAKS AND NEWSCASTS
	{ mixtape = false	,SongString = "When Good Heists go Bad Newscast",				SongData = "M01",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "I'm Free Falling Newscast",					SongData = "M02",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "We're Going to Need Bigger Guns Newscast",			SongData = "M03",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Steelport Here I Am Newscast",					SongData = "M04",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Party Time Newscast",						SongData = "M05",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Hit the Powder Room Newscast",					SongData = "NEWSCAST_SH01",						station = "NEWSCAST" },
	{ mixtape = false	,SongString = "The Belgian Problem Destroy Choice Newscast",			SongData = "M06_BUILDING_GONE",						station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "The Belgian Problem Save Choice Newscast",			SongData = "M06_BUILDING_STAY",						station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Return to Steelport Newscast",					SongData = "M07",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Trojan Whores Newscast",						SongData = "M08",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Pimps Up, Hos Down Newscast",					SongData = "NEWSCAST_SH02",						station = "NEWSCAST" },
	{ mixtape = false	,SongString = "The Ho Boat Newscast",						SongData = "M09",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Gang Bang Newscast",						SongData = "M10",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Convoy Decoy Newscast",						SongData = "M11",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Nyte Blade's Return Newscast",					SongData = "M12",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "STAG Party Newscast",						SongData = "M13",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Live! With Killbane Newscast",					SongData = "M14",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Learning Computer Newscast",					SongData = "M15",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Stop All the Downloading Newscast",				SongData = "NEWSCAST_SH03",						station = "NEWSCAST" },
	{ mixtape = false	,SongString = "deckers.die Newscast",						SongData = "M16",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "My Name is Cyrus Temple Newscast",				SongData = "M17",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Air Steelport Newscast",						SongData = "M18",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Zombie Attack! Newscast",					SongData = "M19",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Remote Chance Newscast",						SongData = "M20",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "3 Count Beatdown Newscast",					SongData = "NEWSCAST_SH04",						station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Murderbrawl XXXI Newscast",					SongData = "M21",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Three Way Killbane Choice Newscast",				SongData = "M22_KILL_KILLBANE",						station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Three Way Hero Choice Newscast",					SongData = "M22_SAVE_SAINTS",						station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "STAG Film Newscast",						SongData = "M23",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Gangstas in Space Newscast",					SongData = "M24",							station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Nyteblade Protest Newscast",					SongData = "NEWSCAST_NIGHTBLADE_PROTEST_1",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Nyteblade STAG Newscast 1",					SongData = "NEWSCAST_NIGHTBLADE_STAG_1",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Nyteblade STAG Newscast 2",					SongData = "NEWSCAST_NIGHTBLADE_STAG_2",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Saints Betrayal Newscast 1",					SongData = "NEWSCAST_SAINTS_BETRAYAL_1",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Saints Betrayal Newscast 2",					SongData = "NEWSCAST_SAINTS_BETRAYAL_2",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Saints Celebrity Newscast 1",					SongData = "NEWSCAST_SAINTS_CELEBRITY_1",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Saints Celebrity Newscast 2",					SongData = "NEWSCAST_SAINTS_CELEBRITY_2",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Saints Celebrity Newscast 3",					SongData = "NEWSCAST_SAINTS_CELEBRITY_3",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "STAG Protest Newscast 1",					SongData = "NEWSCAST_STAG_PROTEST_1",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "STAG Protest Newscast 2",					SongData = "NEWSCAST_STAG_PROTEST_2",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "STAG Rallies Newscast 1",					SongData = "NEWSCAST_STAG_RALLIES_1",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "STAG Rallies Newscast 2",					SongData = "NEWSCAST_STAG_RALLIES_2",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Weather Fall Newscast",						SongData = "NEWSCAST_WEATHER_FALL",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Weather Halloween Newscast 1",					SongData = "NEWSCAST_WEATHER_HALLOWEEN_1",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Weather Halloween Newscast 2",					SongData = "NEWSCAST_WEATHER_HALLOWEEN_2",				station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Weather Winter Newscast 1",					SongData = "NEWSCAST_WEATHER_WINTER_1",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Weather Winter Newscast 2",					SongData = "NEWSCAST_WEATHER_WINTER_2",					station = "NEWSCAST" },
	{ mixtape = false	,SongString = "Killbane Interview Part 1",					SongData = "M14_INTERVIEW_PART1",					station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Killbane Interview Part 2",					SongData = "M14_INTERVIEW_PART2",					station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Killbane Interview Part 3",					SongData = "M14_INTERVIEW_PART3",					station = "NEWSBREAK" },
	{ mixtape = false	,SongString = "Killbane Interview Part 4",					SongData = "M14_INTERVIEW_PART4",					station = "NEWSBREAK" },

	-- MISSION MUSIC
	{ mixtape = false	,SongString = "When Good Heists Go Bad - Score Start",							SongData = "M01_SCORE_Z01_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "When Good Heists Go Bad - Transition",							SongData = "M01_SCORE_Z02_TRANSITION",		station = "MISSION" },
	{ mixtape = false	,SongString = "When Good Heists Go Bad - Plant Explosives",						SongData = "M01_CHECKPOINT_PLANT",		station = "MISSION" },
	{ mixtape = false	,SongString = "When Good Heists Go Bad - Transition 2",							SongData = "M01_SCORE_Z03_TRANSITION",		station = "MISSION" },
	{ mixtape = false	,SongString = "When Good Heists Go Bad - SWAT",								SongData = "M01_SCORE_SWAT",			station = "MISSION" },
	{ mixtape = false	,SongString = "I'm Free Falling - Part 1",								SongData = "M02_SCORE_CHECKPOINT_01",		station = "MISSION" },
	{ mixtape = false	,SongString = "I'm Free Falling - Part 2",								SongData = "M02_SCORE_CHECKPOINT_02",		station = "MISSION" },
	{ mixtape = false	,SongString = "I'm Free Falling - Plane Approach",							SongData = "M02_SCORE_PLANE_APPROACH",		station = "MISSION" },
	{ mixtape = false	,SongString = "We're Going to Need Bigger Guns - UAV Drone",						SongData = "M03_HELI_INTRO_SCORE",		station = "MISSION" },
	{ mixtape = false	,SongString = "We're Going to Need Bigger Guns - Helicopter Rail Sequence",				SongData = "M03_HELI_RAIL_SCORE_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "Party Time - Helicopter Chase",								SongData = "M05_MORNINGSTAR_MUSIC",		station = "MISSION" },
	{ mixtape = false	,SongString = "The Belgian Problem - Cloning Lab",							SongData = "M06_MUSIC_CLONING_LAB",		station = "MISSION" },
	{ mixtape = false	,SongString = "The Belgian Problem - Ball drop",							SongData = "M06_MUSIC_LOADING_DOCK",		station = "MISSION" },
	{ mixtape = false	,SongString = "Trojan Whores - Ben and Aaron Wheeler Feat. Nigel Thompson - Honeys in the Place",	SongData = "M05_SAINTS_MUSIC",			station = "MISSION" },
	{ mixtape = false	,SongString = "The Ho Boat - Incoming attack",								SongData = "M09_BOAT_MUSIC_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "The Ho Boat - Helicopter Rail Sequence",							SongData = "M09_RAIL_MUSIC_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "Gang Bang - Chase",									SongData = "M10_CHASE_MUSIC",			station = "MISSION" },
	{ mixtape = false	,SongString = "Gang Bang - Rooftop",									SongData = "M10_AMB_ROOFTOP",			station = "MISSION" },
	{ mixtape = false	,SongString = "Nyte Blade's Return - PR Center",							SongData = "M12_MUSIC_ESCAPE_PR_CENTER",	station = "MISSION" },
	{ mixtape = false	,SongString = "Nyte Blade's Return - Drive to HQ",							SongData = "M12_MUSIC_DRIVE_TO_SAINTS_HQ",	station = "MISSION" },
	{ mixtape = false	,SongString = "Learning Computer - PR Center Battle",							SongData = "M15_MUSIC_PR_CENTER_BATTLE",	station = "MISSION" },
	{ mixtape = false	,SongString = "Learning Computer - Garage",								SongData = "M15_MUSIC_PR_GARAGE_CHECKPOINT",	station = "MISSION" },
	{ mixtape = false	,SongString = "Learning Computer - Chase",								SongData = "M15_MUSIC_TRUCK_CHASE_CHECKPOINT",	station = "MISSION" },
	{ mixtape = false	,SongString = "deckers.die - Part 1",									SongData = "M16_MUSIC_01_PLAY",			station = "MISSION" },
	{ mixtape = false	,SongString = "deckers.die - Part 2",									SongData = "M16_MUSIC_01B_PLAY",		station = "MISSION" },
	{ mixtape = false	,SongString = "deckers.die - Part 3",									SongData = "M16_MUSIC_02_PLAY",			station = "MISSION" },
	{ mixtape = false	,SongString = "deckers.die - Pre-Boss",									SongData = "M16_PRE_BOSS_MUSIC",		station = "MISSION" },
	{ mixtape = false	,SongString = "deckers.die - Boss Fight",								SongData = "M16_BOSS_MUSIC_PLAY",		station = "MISSION" },
	{ mixtape = false	,SongString = "My Name is Cyrus Temple - Part 1",							SongData = "M17_MUSIC_A",			station = "MISSION" },
	{ mixtape = false	,SongString = "My Name is Cyrus Temple - Part 2",							SongData = "M17_MUSIC_B",			station = "MISSION" },
	{ mixtape = false	,SongString = "Air Steelport - Mission Start",								SongData = "M18_MUSIC_MISSION_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "Air Steelport - Cargo Plane",								SongData = "M18_MUSIC_CARGO_PLANE_CHECKPOINT",	station = "MISSION" },
	{ mixtape = false	,SongString = "Air Steelport - Tank Skydive",								SongData = "M18_MUSIC_TANK_SKYDIVE",		station = "MISSION" },
	{ mixtape = false	,SongString = "Air Steelport - Crash",									SongData = "M18_MUSIC_PLANE_CRASH",		station = "MISSION" },
	{ mixtape = false	,SongString = "Zombie Attack! - Drive to Arapice Island",						SongData = "M19_MUSIC_MISSION_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "Zombie Attack! - Arrival",								SongData = "M19_MUSIC_ZOMBIE_ISLAND",		station = "MISSION" },
	{ mixtape = false	,SongString = "Zombie Attack! - Poisoned",								SongData = "M19_MUSIC_PC_POISONED",		station = "MISSION" },
	{ mixtape = false	,SongString = "STAG Film - City Under Siege",								SongData = "M23_MUSIC_MISSION_START",		station = "MISSION" },
	{ mixtape = false	,SongString = "STAG Film - Daedalus Battle",								SongData = "M23_MUSIC_DAEDALUS_BATTLE",		station = "MISSION" },
	{ mixtape = false	,SongString = "STAG Film - Cyrus Fight",								SongData = "M23_MUSIC_CYRUS_BOSS_FIGHT",	station = "MISSION" },

}

local MixxData = {}
local K12Data = {}
local KrunchData = {}
local KlassicData = {}
local SwimData = {}
local KabronData = {}
local KrhymeData = {}
local GenxData = {}
local MixtapeData = {}
local MissionData = {}
local CommercialData = {}
local NewsData = {}

local radio_song_status = "off"
local current_radio_song = ""
local Custom_Radio_Handle = INVALID_THREAD_HANDLE
local CUSTOM_RADIO_THREAD_ON = 1

local Mixx_Counter = 1
local K12_Counter = 1
local Krunch_Counter = 1
local Klassic_Counter = 1
local Swim_Counter = 1
local Kabron_Counter = 1
local Krhyme_Counter = 1
local Genx_Counter = 1
local Mixtape_Counter = 1
local Mission_Counter = 1
local Commercial_Counter = 1
local News_Counter = 1

--Buttons:
B_INSERT = "CBA_TOW_TRUCK_TOWING_RIGHT"
B_HOME = "CBA_TOW_TRUCK_RELEASE_VEHICLE"
B_PGUP = "CBA_WRECKER_RETRACT_CORD"
B_DELETE = "CBA_TOW_TRUCK_TOWING_LEFT"
B_END = "CBA_OFC_MULTI_PRATFALL"
B_PGDWN = "CBA_WRECKER_EXTEND_CORD"
B_RIGHT = "CBA_VDC_HYDRAULICS_FULLY_EXTEND_TOGGLE"
B_DOWN = "CBA_VDC_HYDRAULICS_TOGGLE"
B_LEFT = "CBA_DBNO_SELF_REVIVAL"
B_UP = "CBA_FIGHT_CLUB_BLOCK"
B_LBRACKET = "CBA_OFC_DEBUG_PRATFALL"
B_RBRACKET = "CBA_OFC_TAUNT_ONE"
B_SEMICOLON = "CBA_MP_SCOREBOARD"

--[[
NOTE: The following have problems and only work intermittently if at all
B_FWDSLASH = "CBA_OFC_MULTI_PRATFALL"
B_END = "CBA_OFC_AUDIO_PLAYER_PREV_TRACK"
CBA_OFC_AUDIO_PLAYER_NEXT_TRACK
]]

local KEYCOMBO_THREAD_ON = 1
local Keycombo_Handle = INVALID_THREAD_HANDLE
SANDBOX_COP_NOTORIETY_CHECK = 0.0

-- Command variables
COOP_COMMANDS = false
POWERED = false
DRUGGED_COUNTER = 1
DRUNK_COUNTER = 1
CYBER = false
BRUTE_ANIM = false
SANDBOX_TEAM = 2
STAG_AROUND = true
HATE_THOSE_SAINTS = true
RESTRICTED_ZONE_NOTORIETY = false
NOTORIETY_ZERO = true
GRAVITY_ON = true
AVATAR_MORPH = false
PLAYER_VISIBLE = true
PLAYER_VULNERABLE = true
VEHICLE_INVULNERABLE = false
VEHICLE_MASS = false
VEHICLE_LOCKED = false
VEHICLE_NOFLIP = false
animation_set_swapped = 0
ZOMBIE_CHEAT = false
MASCOT_CHEAT = false
PIMPS_CHEAT = false

-- Pivot states for key combos
SPRINT_PUSHED = false
RECRUIT_PUSHED = false
TAUNT_PUSHED = false
COMPLIMENT_PUSHED = false
CROUCH_PUSHED = false
USE_PUSHED = false
GRENADE_PUSHED = false
RELOAD_PUSHED = false
MELEE_PUSHED = false
ONE_PUSHED = false
TWO_PUSHED = false
THREE_PUSHED = false
FOUR_PUSHED = false
FIVE_PUSHED = false
SIX_PUSHED = false
SEVEN_PUSHED = false
EIGHT_PUSHED = false

--Used for custom teleports
Dock_Posx = 431.795
Dock_Posy = 936.46
Dock_Posz = 8.105

-- counters used to for music and radio
CURRENT_MUSIC = ""
MUSIC_COUNTER_M01 = 1
MUSIC_COUNTER_M02_M03 = 1
MUSIC_COUNTER_M05_M08 = 1
MUSIC_COUNTER_M06_M09 = 1
MUSIC_COUNTER_M10_M12 = 1
MUSIC_COUNTER_M15 = 1
MUSIC_COUNTER_M16 = 1
MUSIC_COUNTER_M17_M18 = 1
MUSIC_COUNTER_M19 = 1
MUSIC_COUNTER_M21_M22 = 1
MUSIC_COUNTER_M23 = 1

-- Zone Variables for toggling
Daedalus_State = true
Safeword_State = true
Nukeplant_State = true
ThreeCount_State = true
Bridge_State = true
Statue_State = true
Zombie_State = true
Therm_Count = 1 -- Thermopylae, Loren Building, SaintsHQ and Stilwater bank have 3 states that the counter cycles through
Loren_Count = 1
Stilwater_Count = 1
SaintsHQ_Count = 1
Barge_State = true
Hoboat_State = true
DeckerVR_State = true
Murderbrawl_State = true
Mars_State = true
Cyberblazing_State = true
MayorOffice_State = true
LorenJet_State = true

-- Weapon cycle variables
SLOT_TWO = 1
SLOT_THREE = 1
SLOT_FOUR = 1
SLOT_FIVE = 1
SLOT_SIX = 1
SLOT_SEVEN = 1
SLOT_EIGHT = 1
SLOT_TEMP = 1
DUAL_WIELD_CYCLE = false
UNLIMITED_AMMO_CYCLE = false

-- Counter to Cycle through mission and normal outfits
Outfit_Counter_Mission = 1
Outfit_Counter_Male = 1
Outfit_Counter_Female = 1

--time of day and weather variables for day/night cycle
TOD_Handle = INVALID_THREAD_HANDLE
TOD_Span = "changeyou"
TOD_Last_Check = "changme"
TOD_State = true
TOD_Count = 1
Alt_TOD_Count = 1
APOCALYPSE_TOD = false

--Sandbox+ HUD messages flag
HUD_MSG = true -- this flag controls whether or not to display activation keycombo messages

-- Tutorial flag to disable all popups
Tutorial_Disable_Flag = true

-- Attach effects thread vars
Effects_Handle = INVALID_THREAD_HANDLE
EFFECTS_THREAD_ON = 1
effects_count = 1
effects_current = ""
effects_delay = 0.5
effects_toggle = false
effects_attach = "head"

-- BadMadScientist tracked variables for his commands
FOLLOWERS_PSYCHO = true
FOLLOWERS_DANCE = true
passenger_activated = 0
flwr_weaps = 1

-- HUD Stuff
local Openworld_hud_state = {
	hide_minimap = -1,
	hide_everything = -1
}
HUD_NORMAL = true

-- Facial expression stuff
FACE_COUNTER = 1



-- *****  VANILLA VARIABLES *****

-- Gameplay Choice IDs -
-- these should match values from level_scripts.cpp
MISSION_06_CHOICE = 0
MISSION_22_CHOICE = 1
MISSION_21_CHOICE = 2
M06_CHOICE_BLOWN_TOWER = true;
M06_CHOICE_BRANDED_TOWER = false;
M22_CHOICE_KILLBANE_KILL = true;
M22_CHOICE_KILLBANE_ESCAPE = false;
M21_CHOICE_KILLBANE_UNMASKED = true;
M21_CHOICE_KILLBANE_NOT_UNMASKED = false;


-- ********************************************************

function sr3_city_init()
	debug_print("sr3_city_init() processed".."\n")
end


function sr3_city_main()
	debug_print("sr3_city_main() processed".."\n")
	Keycombo_Handle = thread_new("keycombo_thread")
	TOD_Handle = thread_new ("tod_thread")
	Effects_Handle = thread_new("effects_thread")
	Custom_Radio_Handle = thread_new("custom_radio_monitor")

	local table_status, table_err = pcall(Create_Radio_Station_Tables(randomize_music))
	if table_status == false then
		debug_print(tostring(table_err) .. "\n")
	end
end

function Create_Radio_Station_Tables(randomize)
	-- This function is for the on foot radio. It loops through the big RadioData table and populates a bunch of individual station tables
	-- with specfic songs. This is so the player can remove lines or change mixtape to true/false for his playlist in RadioData and still
	-- have it dynamically build everything correctly.

	local MixxIndex = 1
	local K12Index = 1
	local KrunchIndex = 1
	local KlassicIndex = 1
	local SwimIndex = 1
	local KabronIndex = 1
	local KrhymeIndex = 1
	local GenxIndex = 1
	local MissionIndex = 1
	local MixtapeIndex = 1
	local CommercialIndex = 1
	local NewsIndex = 1
	local entries = {}

	kill_radio_music()
	if randomize == "on" then
		shuffle(RadioData)
	end
	for idx, song in pairs(RadioData) do
		if song.station == "MIXX" then
			local entry = { playnumber = MixxIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			MixxData[MixxIndex] = entry
			MixxIndex = MixxIndex + 1
		elseif song.station == "K12" then
			local entry = { playnumber = K12Index, SongString = song.SongString, SongData = song.SongData, station = song.station }
			K12Data[K12Index] = entry
			K12Index = K12Index + 1
		elseif song.station == "KRUNCH" then
			local entry = { playnumber = KrunchIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			KrunchData[KrunchIndex] = entry
			KrunchIndex = KrunchIndex + 1
		elseif song.station == "KLASSIC" then
			local entry = { playnumber = KlassicIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			KlassicData[KlassicIndex] = entry
			KlassicIndex = KlassicIndex + 1
		elseif song.station == "SWIM" then
			local entry = { playnumber = SwimIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			SwimData[SwimIndex] = entry
			SwimIndex = SwimIndex + 1
		elseif song.station == "KABRON" then
			local entry = { playnumber = KabronIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			KabronData[KabronIndex] = entry
			KabronIndex = KabronIndex + 1
		elseif song.station == "KRHYME" then
			local entry = { playnumber = KrhymeIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			KrhymeData[KrhymeIndex] = entry
			KrhymeIndex = KrhymeIndex + 1
		elseif song.station == "GENX" then
			local entry = { playnumber = GenxIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			GenxData[GenxIndex] = entry
			GenxIndex = GenxIndex + 1
		elseif song.station == "MISSION" then
			local entry = { playnumber = MissionIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			MissionData[MissionIndex] = entry
			MissionIndex = MissionIndex + 1
		elseif song.station == "COMMERCIAL" then
			local entry = { playnumber = CommercialIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			CommercialData[CommercialIndex] = entry
			CommercialIndex = CommercialIndex + 1
		elseif song.station == "NEWSBREAK" or song.station == "NEWSCAST" then
			local entry = { playnumber = NewsIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			NewsData[NewsIndex] = entry
			NewsIndex = NewsIndex + 1
		end

		-- any RadioData table entry with mixtape set to true will add that song to the on-foot mixtape table
		if song.mixtape then
			local entry = { playnumber = MixtapeIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			MixtapeData[MixtapeIndex] = entry
			MixtapeIndex = MixtapeIndex + 1
		end
	end
end

function shuffle(table)
	local tmpCounter = #table
	while tmpCounter >= 2 do
		local random_pos = rand_int(1,tmpCounter)
		table[tmpCounter], table[random_pos] = table[random_pos], table[tmpCounter]
		tmpCounter = tmpCounter - 1
	end
	return table
end

function advance_next_song(station)
	if station == "Mixx" then
		for idx, song in pairs(MixxData) do
			if song.playnumber == Mixx_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Mixx_Counter == #MixxData then
			Mixx_Counter = 1
		else
			Mixx_Counter = Mixx_Counter + 1
		end
		radio_song_status = "Mixx"
	elseif station == "K12" then
		for idx, song in pairs(K12Data) do
			if song.playnumber == K12_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if K12_Counter == #K12Data then
			K12_Counter = 1
		else
			K12_Counter = K12_Counter + 1
		end
		radio_song_status = "K12"
	elseif station == "Krunch" then
		for idx, song in pairs(KrunchData) do
			if song.playnumber == Krunch_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Krunch_Counter == #KrunchData then
			Krunch_Counter = 1
		else
			Krunch_Counter = Krunch_Counter + 1
		end
	elseif station == "Klassic" then
		for idx, song in pairs(KlassicData) do
			if song.playnumber == Klassic_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Klassic_Counter == #KlassicData then
			Klassic_Counter = 1
		else
			Klassic_Counter = Klassic_Counter + 1
		end
		radio_song_status = "Klassic"
	elseif station == "Swim" then
		for idx, song in pairs(SwimData) do
			if song.playnumber == Swim_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Swim_Counter == #SwimData then
			Swim_Counter = 1
		else
			Swim_Counter = Swim_Counter + 1
		end
		radio_song_status = "Swim"
	elseif station == "Kabron" then
		for idx, song in pairs(KabronData) do
			if song.playnumber == Kabron_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Kabron_Counter == #KabronData then
			Kabron_Counter = 1
		else
			Kabron_Counter = Kabron_Counter + 1
		end
		radio_song_status = "Kabron"
	elseif station == "Krhyme" then
		for idx, song in pairs(KrhymeData) do
			if song.playnumber == Krhyme_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Krhyme_Counter == #KrhymeData then
			Krhyme_Counter = 1
		else
			Krhyme_Counter = Krhyme_Counter + 1
		end
		radio_song_status = "Krhyme"
	elseif station == "Genx" then
		for idx, song in pairs(GenxData) do
			if song.playnumber == Genx_Counter then
				current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Genx_Counter == #GenxData then
			Genx_Counter = 1
		else
			Genx_Counter = Genx_Counter + 1
		end
		radio_song_status = "Genx"
	elseif station == "Mission" then
		for idx, song in pairs(MissionData) do
			if song.playnumber == Mission_Counter then
				current_radio_song = audio_object_post_event(song.SongData, nil, nil, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Mission_Counter == #MissionData then
			Mission_Counter = 1
		else
			Mission_Counter = Mission_Counter + 1
		end
		radio_song_status = "Mission"
	elseif station == "Commercial" then
		for idx, song in pairs(CommercialData) do
			if song.playnumber == Commercial_Counter then
				current_radio_song = audio_object_post_event("RADIO_COMMERCIALS", "RADIO_COMMERCIALS", song.SongData, LOCAL_PLAYER)
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Commercial_Counter == #CommercialData then
			Commercial_Counter = 1
		else
			Commercial_Counter = Commercial_Counter + 1
		end
		radio_song_status = "Commercial"
	elseif station == "News" then
		for idx, song in pairs(NewsData) do
			if song.playnumber == News_Counter then
				if song.station == "NEWSCAST" then
					current_radio_song = audio_object_post_event("RADIO_COMMERCIALS", "RADIO_COMMERCIALS", song.SongData, LOCAL_PLAYER)
				elseif song.station == "NEWSBREAK" then
					current_radio_song = audio_object_post_event("RADIO_NEWS_BREAKS", "RADIO_NEWS_BREAKS", song.SongData, LOCAL_PLAYER)
				end
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if News_Counter == #NewsData then
			News_Counter = 1
		else
			News_Counter = News_Counter + 1
		end
		radio_song_status = "News"
	elseif station == "Mixtape" then
		for idx, song in pairs(MixtapeData) do
			if song.playnumber == Mixtape_Counter then
				if song.station == "MISSION" then
					current_radio_song = audio_object_post_event(song.SongData, nil, nil, LOCAL_PLAYER)
				elseif song.station == "NEWSCAST" or song.station == "COMMERCIAL" then
					current_radio_song = audio_object_post_event("RADIO_COMMERCIALS", "RADIO_COMMERCIALS", song.SongData, LOCAL_PLAYER)
				elseif song.station == "NEWSBREAK" then
					current_radio_song = audio_object_post_event("RADIO_NEWS_BREAKS", "RADIO_NEWS_BREAKS", song.SongData, LOCAL_PLAYER)
				else
					current_radio_song = audio_object_post_event("RADIO_SONGS", "RADIO_SONGS", song.SongData, LOCAL_PLAYER)
				end
				sandboxplus_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Mixtape_Counter == #MixtapeData then
			Mixtape_Counter = 1
		else
			Mixtape_Counter = Mixtape_Counter + 1
		end
		radio_song_status = "Mixtape"
	end
end

function custom_radio_monitor()
	local playtest
	while CUSTOM_RADIO_THREAD_ON == 1 do
		if radio_song_status == "off" then
		else
			playtest = audio_is_playing(current_radio_song)
			if not playtest then
				advance_next_song(radio_song_status)
			end
		end
	delay(4.0)
	end
end

function kill_radio_music()
	audio_stop(current_radio_song)
	radio_song_status = "off"
end

function tod_thread()
	while TOD_THREAD_ON == 1 do
		if (not mission_is_active()) then
			tod_advance_check()
		end
		delay(1.0)
	end
end

function effects_thread()
	while EFFECTS_THREAD_ON == 1 do
		if effects_toggle then
			explosion_create(effects_current, LOCAL_PLAYER)
			if COOP_COMMANDS and coop_is_active() then
				explosion_create(effects_current, REMOTE_PLAYER)
			end
		end
		delay(effects_delay)
	end
end


function keycombo_thread()
	while KEYCOMBO_THREAD_ON == 1 do
		--following debug is handy for grabbing cutscenes coords if you have the debug dll and a command window up
		--local posx,posz,posy = get_object_pos(LOCAL_PLAYER)
		--debug_print("Player Pos: " .. posx .. " " .. posy .. " " .. posz .."\n")
		SANDBOX_COP_NOTORIETY_CHECK = notoriety_get_decimal("police")
		if POLICE_SHOOT_FROM_VEHICLES and not mission_is_active() and SANDBOX_COP_NOTORIETY_CHECK >= 3.0 then
			set_cops_shooting_from_vehicles(true)
		elseif POLICE_SHOOT_FROM_VEHICLES and not mission_is_active() and SANDBOX_COP_NOTORIETY_CHECK < 3.0 then
			set_cops_shooting_from_vehicles(false)
		elseif not POLICE_SHOOT_FROM_VEHICLES and not mission_is_active() then
			set_cops_shooting_from_vehicles(false)
		end
		if player_action_is_pressed("CBA_OFC_SPRINT") then -- SHIFT (sprint) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not SPRINT_PUSHED then
				--TELEPORT TO SAFEWORD
				local tposx,tposy,tposz = (-1170.99 - Dock_Posx), (-514.88 - Dock_Posy), 39.94
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Safeword")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not SPRINT_PUSHED then
				--TELEPORT TO NUKE PLANT
				local tposx,tposy,tposz = (1262.67 - Dock_Posx), (-1090.44 - Dock_Posy), 60.01
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Nuke Plant")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not SPRINT_PUSHED then
				--TELEPORT TO 3 COUNT
				local tposx,tposy,tposz = (1199.26 - Dock_Posx), (1353.83 - Dock_Posy), 24.16
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to 3 Count")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not SPRINT_PUSHED then
				--TELEPORT TO SAINTS HQ PENTHOUSE
				teleport_to_object(LOCAL_PLAYER, "Crib_SaintsHQ", false, nil, 0.5)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Crib_SaintsHQ", false, nil, 0.5)
				end
				sandboxplus_message("Teleported to Saints HQ")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not SPRINT_PUSHED then
				--TELEPORT TO AIRPLANE HANGAR
				local tposx,tposy,tposz = (-1417.834 - Dock_Posx), (-1227.572 - Dock_Posy), 11.072
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Airplane Hangar")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not SPRINT_PUSHED then
				--TELEPORT TO RONDINI DOCKS
				local tposx,tposy,tposz = (468.128 - Dock_Posx), (936.170 - Dock_Posy), -3.678
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				--teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, nil, 0.5)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Rondini Docks")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not SPRINT_PUSHED then
				--TELEPORT TO ZIMOS' PAD
				local tposx,tposy,tposz = (-1206.83 - Dock_Posx), (145.12 - Dock_Posy), 6.09
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Zimos' Pad")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not SPRINT_PUSHED then
				--TELEPORT TO ANGEL'S GYM
				local tposx,tposy,tposz = (804.36 - Dock_Posx), (1001.13 - Dock_Posy), 11.32
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Angel's Gym")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not SPRINT_PUSHED then
				--TELEPORT TO KINZIE'S WAREHOUSE
				local tposx,tposy,tposz = (2120.85 - Dock_Posx), (-255.69 - Dock_Posy), 4.01
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				sandboxplus_message("Teleported to Kinzie's Warehouse")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not SPRINT_PUSHED then
				--TELEPORT TO SHAUNDI'S EX'S LOFT
				teleport_to_object(LOCAL_PLAYER, "Crib_Shaundis_Ex", false, nil, 0.5)
				sandboxplus_message("Teleported to Shaundi's Ex's Loft")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Crib_Shaundis_Ex", false, nil, 0.5)
				end
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not SPRINT_PUSHED then
				--TELEPORT TO STATUE
				local tposx,tposy,tposz = (-638.61 - Dock_Posx), (1016.118 - Dock_Posy), 185.704
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to top of statue")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not SPRINT_PUSHED then
				--TELEPORT TO MILITARY BASE
				local tposx,tposy,tposz = (-874.92 - Dock_Posx), (332.57 - Dock_Posy), 4.03
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Military Base")
				SPRINT_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not SPRINT_PUSHED then
				-- TELEPORT TO POWDER ROOM
				local tposx,tposy,tposz = (395.538 - Dock_Posx), (69.487 - Dock_Posy), 5.183
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Powder Room")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				SPRINT_PUSHED = true
			end



		elseif player_action_is_pressed("CBA_GAC_RECRUIT_DISMISS") then -- Z (recruit/dismiss) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not RECRUIT_PUSHED then
				--TELEPORT TO DECKER VIRTUAL REALITY
				city_zone_swap("vr",true)
				local tposx,tposy,tposz = (-2029.221 - Dock_Posx), (1935.252 - Dock_Posy), 1087.409
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Decker Virtual Reality")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not RECRUIT_PUSHED then
				-- TELEPORT TO DECKERS.DIE TANK BATTLE ARENA
				city_zone_swap("vr",true)
				local tposx,tposy,tposz = (-2062.020 - Dock_Posx), (2030.559 - Dock_Posy), 1116.811
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to tank battle arena")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not RECRUIT_PUSHED then
				--TELEPORT INSIDE REACTOR
				city_zone_swap("nuke1",false)
				city_zone_swap("nuke2",false)
				city_zone_swap("int_sh03",false)
				city_zone_swap("int_sh03c",false)
				local tposx,tposy,tposz = (1350.001 - Dock_Posx), (-1236.288 - Dock_Posy), 26.294
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Nuke Plant reactor")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not RECRUIT_PUSHED then
				-- TELEPORT TO CYBER BLAZING INTERNAL
				city_zone_swap("vrtb",true)
				local tposx,tposy,tposz = (-2650.303 - Dock_Posx), (-2142.708 - Dock_Posy), 307.727
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to inside Cyber Blazing track")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not RECRUIT_PUSHED then
				-- TELEPORT TO CYBER BLAZING EXTERNAL
				city_zone_swap("vrtb",true)
				local tposx,tposy,tposz = (-2650.303 - Dock_Posx), (-2142.708 - Dock_Posy), 350.727
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to on top of Cyber Blazing track")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not RECRUIT_PUSHED then
				--TELEPORT TO DECKER BARGE
				city_zone_swap("barge",true)
				local tposx,tposy,tposz = (-705.117 - Dock_Posx), (-199.417 - Dock_Posy), 1.00
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Decker Barge")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not RECRUIT_PUSHED then
				--TELEPORT TO MURDERBRAWL INSIDE RING
				city_zone_swap("m21",true)
				local tposx,tposy,tposz = (2709.856 - Dock_Posx), (-2527.081 - Dock_Posy), 123.097
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Murderbrawl ring")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not RECRUIT_PUSHED then
				--TELEPORT TO MURDERBRAWL OUTSIDE RING
				city_zone_swap("m21",true)
				local tposx,tposy,tposz = (2709.280 - Dock_Posx), (-2516.698 - Dock_Posy), 121.096
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Murderbrawl floor")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not RECRUIT_PUSHED then
				-- TELEPORT TO MARS
				city_zone_swap("Mars",true)
				local tposx,tposy,tposz = (-160.480 - Dock_Posx), (-2515.595 - Dock_Posy), 1073.447
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Mars")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not RECRUIT_PUSHED then
				--TELEPORT TO THE HO BOAT
				city_zone_swap("cargo",true)
				local tposx,tposy,tposz = (2496.53 - Dock_Posx), (-1.614 - Dock_Posy), 3.148
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to The Ho Boat")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not RECRUIT_PUSHED then
				-- TELEPORT TO LOREN BUILDING INTERIOR GARAGE
				city_zone_swap("tower_saints",false)
				city_zone_swap("tower_dmg",false)
				city_zone_swap("m6",false)
				local tposx,tposy,tposz = (-230.648 - Dock_Posx), (-773.185 - Dock_Posy), 12.597
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Loren Building Garage")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not RECRUIT_PUSHED then
				-- TELEPORT TO LOREN BUILDING INTERIOR CLONING LAB
				city_zone_swap("tower_saints",false)
				city_zone_swap("tower_dmg",false)
				city_zone_swap("m6",false)
				local tposx,tposy,tposz = (-266.593 - Dock_Posx), (-799.387 - Dock_Posy), 70.000
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Loren Building cloning lab")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not RECRUIT_PUSHED then
				-- TELEPORT TO LOREN BUILDING INTERIOR OFFICES
				city_zone_swap("tower_saints",false)
				city_zone_swap("tower_dmg",false)
				city_zone_swap("m6",false)
				--TELEPORT TO Loren Offices
				local tposx,tposy,tposz = (-280.654 - Dock_Posx), (-781.561 - Dock_Posy), 907.506
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Loren Offices")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			end



		elseif player_action_is_pressed("CBA_OFC_TAUNT_TWO") then -- X (taunt) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not TAUNT_PUSHED then
				-- TELEPORT TO CORNER STORE
				local tposx,tposy,tposz = (376.685 - Dock_Posx), (-78.121 - Dock_Posy), 5.170
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to the corner store")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not TAUNT_PUSHED then
				-- TELEPORT TO STAG PR CENTER LOBBY
				local tposx,tposy,tposz = (-413.872 - Dock_Posx), (-129.370 - Dock_Posy), 5.100
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to STAG PR Center")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not TAUNT_PUSHED then
				-- TELEPORT TO STAG BUILDING OFFICES
                		local tposx,tposy,tposz = (-420.021 - Dock_Posx), (-71.462 - Dock_Posy), 26.005
                		teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
                		sandboxplus_message("Teleported to STAG Building Offices")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not TAUNT_PUSHED then
				-- TELEPORT TO TECHNICALLY LEGAL
				local tposx,tposy,tposz = (1023.754 - Dock_Posx), (-601.589 - Dock_Posy), 5.51
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Technically Legal")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not TAUNT_PUSHED then
				-- TELEPORT TO BROKEN SHILLELAGH
				local tposx,tposy,tposz = (-267.755 - Dock_Posx), (347.944 - Dock_Posy), 12.154
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Broken Shillelagh")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not TAUNT_PUSHED then
				-- TELEPORT TO SMILING JACKS
				local tposx,tposy,tposz = (1757.070 - Dock_Posx), (-310.287 - Dock_Posy), 4.307
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Smiling Jack's")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not TAUNT_PUSHED then
				-- TELEPORT SAINTS HQ FOYER (courtesy of RetroGangster)
                		local tposx,tposy,tposz = (98.495 - Dock_Posx), (1041.445 - Dock_Posy), 24.131
                		teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
                		sandboxplus_message("Teleported to Saints HQ Foyer")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not TAUNT_PUSHED then
				-- TELEPORT TO MAYOR'S OFFICE
				city_zone_swap("mayoroff",true)
				local tposx,tposy,tposz = (73.029 - Dock_Posx), (279.050 - Dock_Posy), 236.000
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Mayor's Office")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not TAUNT_PUSHED then
				-- TELEPORT TO THERMOPYLAE INTERIOR
				city_zone_swap("ThermInt1", true) -- swap in the Therm interior just in case
		                local tposx,tposy,tposz = (493.034 - Dock_Posx), (1669.206 - Dock_Posy), 320.755
                		teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
		                sandboxplus_message("Teleported to Thermopylae Interior")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not TAUNT_PUSHED then
-- FIX LOREN JET COORDS
				--TELEPORT TO LOREN JET !!! WARNING BROKEN !!!
				--local tposx,tposy,tposz = (18887.500 - Dock_Posx), (1426.137 - Dock_Posy), 1426.656
				local tposx,tposy,tposz = (18888.045 - Dock_Posx), (1422.218 - Dock_Posy), 1419.0
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Loren's Jet BROKEN")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not TAUNT_PUSHED then
				-- TELEPORT TO Genki SERC
				local tposx,tposy,tposz = (-2241.101 - Dock_Posx), (-654.584 - Dock_Posy), -321.393
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Professor Genki SERC")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not TAUNT_PUSHED then
				-- TELEPORT TO Apocalypse Genki
				local tposx,tposy,tposz = (-2220.056 - Dock_Posx), (-193.106 - Dock_Posy), -391.189
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Apocalypse Genki")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not TAUNT_PUSHED then
				-- TELEPORT TO LIVE WITH KILLBANE INTERVIEW BUILDING
				local tposx,tposy,tposz = (-817.6 - Dock_Posx), (-263.5 - Dock_Posy), 61.4
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Killbane interview building")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			end




		elseif player_action_is_pressed("CBA_OFC_TAUNT_THREE") then -- C (compliment) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not COMPLIMENT_PUSHED then
-- FIX BOUNDARIES FOR BANK
				--TELEPORT TO STILWATER BANK !!!!WARNING BROKEN DUE TO BOUNDARIES!!!!!
				-- INSIDE BANK COORDS FOR START OF m01 BROKEN
				--local tposx,tposy,tposz = (2245.59 - Dock_Posx), (2719.536 - Dock_Posy), 169.005
				city_zone_swap("stilwater",true)
				city_zone_swap("bank_destroy",false)
				city_zone_swap("bank",true)
				-- Changed to northern edge of Stilwater until boundary issue can be addressed
				local tposx,tposy,tposz = (2162.47 - Dock_Posx), (2040.51 - Dock_Posy), 3.37
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Stilwater")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO ABANDONED TRAIN STATION
				local tposx,tposy,tposz = (-382.7 - Dock_Posx), (326.0 - Dock_Posy), 26.0
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Abandoned train station")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true 
			elseif player_action_is_pressed(B_PGUP) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO HIGHEST BUILDING
				city_zone_swap("tower_saints",false)
				city_zone_swap("tower_dmg",false)
				city_zone_swap("m6",false)
				--local tposx,tposy,tposz = (-249 - Dock_Posx), (-724 - Dock_Posy), 975
				local tposx,tposy,tposz = (-241.9 - Dock_Posx), (-775.79 - Dock_Posy), 985.63
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				sandboxplus_message("Teleported to Highest building in the city")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not COMPLIMENT_PUSHED then
				--TELEPORT TO IMAGE AS DESIGNED
				teleport_to_object(LOCAL_PLAYER, "slate_ImageAsDesigned", false, nil, 0.5)
				delay(0.5)
				sandboxplus_message("Teleported to Image as Designed")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "slate_ImageAsDesigned", false, nil, 0.5)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not COMPLIMENT_PUSHED then
				--TELEPORT TO FRIENDLY FIRE
				local tposx,tposy,tposz = (-174.82 - Dock_Posx), (478.89 - Dock_Posy), 5.10
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				delay(0.5)
				sandboxplus_message("Teleported to Friendly Fire")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not COMPLIMENT_PUSHED then
				--TELEPORT TO PLANET SAINTS
				local tposx,tposy,tposz = (-532.41 - Dock_Posx), (-85.75 - Dock_Posy), 7.42
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				delay(0.5)
				sandboxplus_message("Teleported to Planet Saints")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not COMPLIMENT_PUSHED then
				--TELEPORT TO LET'S PRETEND
				local tposx,tposy,tposz = (1228.25 - Dock_Posx), (968.22 - Dock_Posy), 6.57
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				delay(0.5)
				sandboxplus_message("Teleported to Let's Pretend")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not COMPLIMENT_PUSHED then
				--TELEPORT TO NOBODY LOVES ME
				local tposx,tposy,tposz = (1174.66 - Dock_Posx), (-535.51 - Dock_Posy), 4.15
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				delay(0.5)
				sandboxplus_message("Teleported to Nobody Loves Me")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not COMPLIMENT_PUSHED then
				--TELEPORT TO LEATHER AND LACE
				local tposx,tposy,tposz = (-1242.84 - Dock_Posx), (-809.85 - Dock_Posy), 3.40
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				delay(0.5)
				sandboxplus_message("Teleported to Leather and Lace")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not COMPLIMENT_PUSHED then
				--TELEPORT TO RUSTY'S NEEDLE
				local tposx,tposy,tposz = (-270.67 - Dock_Posx), (-295.78 - Dock_Posy), 5.17
				teleport_to_object(LOCAL_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				delay(0.5)
				sandboxplus_message("Teleported to Rusty's Needle")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "Dock_Purchase", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not COMPLIMENT_PUSHED then
				--TELEPORT REMOTE PLAYER TO HOST
				if ( coop_is_active() == true ) then
					if character_is_in_vehicle(LOCAL_PLAYER) then
						vehicle_enter_teleport(REMOTE_PLAYER,get_char_vehicle_name(LOCAL_PLAYER),1)
					else
						teleport_to_object(REMOTE_PLAYER, LOCAL_PLAYER, false, nil, 0.5)
					end
						sandboxplus_message("Remote player teleported to host")
				else
					sandboxplus_message("Teleport remote player to host FAILED")
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not COMPLIMENT_PUSHED then
				--TELEPORT HOST TO REMOTE PLAYER
				if ( coop_is_active() == true ) then
					if character_is_in_vehicle(REMOTE_PLAYER) then
						vehicle_enter_teleport(LOCAL_PLAYER,get_char_vehicle_name(REMOTE_PLAYER),1)
					else
						teleport_to_object(LOCAL_PLAYER, REMOTE_PLAYER, false, nil, 0.5)
					end
					sandboxplus_message("Host teleported to remote player")
				else
					sandboxplus_message("Teleport to remote player FAILED")
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not COMPLIMENT_PUSHED then
				--UNUSED
				COMPLIMENT_PUSHED = true
			end



		elseif player_action_is_pressed("CBA_OFC_CROUCH") then -- CTRL (crouch) - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not CROUCH_PUSHED then
--FIX SUBSTITUTED FX & WEAPON
				--TOGGLE SUPERPOWERS FOR BOTH PLAYERS
				if POWERED then
					remove_superpowers()
					sandboxplus_message("Super Powers DEACTIVATED")
				else
					add_superpowers()
					sandboxplus_message("Super Powers ACTIVATED")
				end
				POWERED = not POWERED
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not CROUCH_PUSHED then
				if effects_count == 1 then
					effects_current = "Ammo - Incendiary"
					effects_delay = 0.1
				elseif effects_count == 2 then
					effects_current = "genki_exp"
					effects_delay = 2
				elseif effects_count == 3 then
					effects_current = "electric_grenade"
					effects_delay = 2
				elseif effects_count == 4 then
					effects_toggle = false
				end
				if effects_count == 4 then
					sandboxplus_message("Attach explosions removed from player")
					effects_toggle = false
					effects_count = 1
				else
					sandboxplus_message("Attach "..effects_current.." to player")
					effects_toggle = true
					effects_count = effects_count + 1
				end
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not CROUCH_PUSHED then
				notoriety_set("deckers",5)
				notoriety_set("luchadores",5)
				notoriety_set("Morningstar",5)
				notoriety_set("police",5)
				sandboxplus_message("Notoriety maxed for all teams")
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not CROUCH_PUSHED then
				if PLAYER_VULNERABLE then
					sandboxplus_message("Player is now invulnerable")
					turn_invulnerable(LOCAL_PLAYER)
					if COOP_COMMANDS and coop_is_active() then
						turn_invulnerable(REMOTE_PLAYER)
					end
				else
					sandboxplus_message("Player is now vulnerable")
					turn_vulnerable(LOCAL_PLAYER)
					if COOP_COMMANDS and coop_is_active() then
						turn_vulnerable(REMOTE_PLAYER)
					end
				end
				PLAYER_VULNERABLE = not PLAYER_VULNERABLE
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_END) and not CROUCH_PUSHED then
				if human_is_downed("#FOLLOWER1#") then
					npc_revive("#FOLLOWER1#")
				elseif human_is_downed("#FOLLOWER2#") then
					npc_revive("#FOLLOWER2#")
				elseif human_is_downed("#FOLLOWER3#") then
					npc_revive("#FOLLOWER3#")
				else
					sandboxplus_message("None of your followers need revival")
				end
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not CROUCH_PUSHED then
				notoriety_reset("deckers")
				notoriety_reset("luchadores")
				notoriety_reset("Morningstar")
				notoriety_reset("Police")
				sandboxplus_message("All notoriety cleared")
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not CROUCH_PUSHED then
				local sandbox_drug_scalar = 0
				if DRUGGED_COUNTER == 1 then
					sandbox_drug_scalar = 0.25
					sandboxplus_message("Player takes drugs - weak")
				elseif DRUGGED_COUNTER == 2 then
					sandbox_drug_scalar = 0.5
					sandboxplus_message("Player takes drugs - medium")
				elseif DRUGGED_COUNTER == 2 then
					sandbox_drug_scalar = 0.75
					sandboxplus_message("Player takes drugs - strong")
				elseif DRUGGED_COUNTER == 3 then
					sandbox_drug_scalar = 1.0
					sandboxplus_message("Player is one with the universe")
				elseif DRUGGED_COUNTER == 4 then
					sandbox_drug_scalar = 0
					sandboxplus_message("Player has cleaned up his life")
				end
				get_fucking_high_bitches(sandbox_drug_scalar)
				if DRUGGED_COUNTER == 4 then
					DRUGGED_COUNTER = 1
				else
					DRUGGED_COUNTER = DRUGGED_COUNTER + 1
				end
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not CROUCH_PUSHED then
				-- CYCLE DRUNK STATE
				if DRUNK_COUNTER == 0 then
					sandboxplus_message("Player sobriety restored")
					drug_effect_set_override_values(0,0)
					customization_restore_player_rig()
					refraction_situation_clear()
					audio_object_post_event("sh02_drug_pitch_normal", nil, nil, LOCAL_PLAYER)
				elseif DRUNK_COUNTER == 1 then
					sandboxplus_message("Player is drunk")
					drug_effect_set_override_values(1,0)
				elseif DRUNK_COUNTER == 2 then
					sandboxplus_message("Player ish really drunk")
					drug_effect_set_override_values(3,0)
					customization_swap_player_rig( "cm_body.rig", "Drunk" )
				elseif DRUNK_COUNTER == 3 then
					sandboxplus_message("What button do I press to talk to the animals?")
					drug_effect_set_override_values(5,0)
					refraction_situation_set("drug weakest")
					audio_object_post_event("sh02_drug_pitch_50", nil, nil, LOCAL_PLAYER)
				end
				if DRUNK_COUNTER == 3 then
					DRUNK_COUNTER = 0
				else
					DRUNK_COUNTER = DRUNK_COUNTER + 1
				end
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not CROUCH_PUSHED then
				if CYBER then
					sandboxplus_message("Reality now restored")
					hdr_bloom_set_multiplier(1)
					refraction_situation_clear()
				else
					sandboxplus_message("Virtual Reality effect enabled")
					hdr_bloom_set_multiplier(1.5)
					refraction_situation_set("cyber_m16")
				end
				CYBER = not CYBER
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not CROUCH_PUSHED then
				if FOLLOWERS_DANCE then	
					set_animation_state(LOCAL_PLAYER, "dance d")	-- Sets dance animations. Feel free to replace them with your own.
					set_animation_state("#FOLLOWER#", "dance a")
					set_animation_state("#FOLLOWER2#", "dance b")
					set_animation_state("#FOLLOWER3#", "dance c")

					sandboxplus_message("Party time!")
				else
					clear_animation_state(LOCAL_PLAYER)
					clear_animation_state("#FOLLOWER#")
					clear_animation_state("#FOLLOWER2#")
					clear_animation_state("#FOLLOWER3#")
					sandboxplus_message("Party's over!")
				end
				FOLLOWERS_DANCE  = not FOLLOWERS_DANCE
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not CROUCH_PUSHED then
-- FIX AVATAR MORPH
				if not AVATAR_MORPH then
					customization_swap_player_rig("avatar.rig","AVATAR")
					boss_battle_matt_set_player_as_avatar(ENABLE)
					sandboxplus_message("Animations set to Avatar")
				else
					if (character_get_gender(LOCAL_PLAYER) == GENDER_TYPE_MALE) then
						customization_swap_player_rig( "cm_body.rig", "Plym" )
						player_super_powered(LOCAL_PLAYER, false)
					else
						customization_swap_player_rig( "cf_body.rig", "Plyf" )

					end
					boss_battle_matt_set_player_as_avatar(DISABLE)
					sandboxplus_message("Animations set to normal player")
				end
				--[[WIP Stuff

				if not AVATAR_MORPH then
					customization_swap_player_rig("avatar.rig","AVATAR")
					boss_battle_matt_set_player_as_avatar(ENABLE)
					teleport_coop("Remote_Boss_Start_Navpoint", "Remote_Boss_Start_Navpoint", true)
					group_create("MATT_GROUP", true)
					sandboxplus_message("Animations set to Avatar")
				else

				end]]
				AVATAR_MORPH = not AVATAR_MORPH
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not CROUCH_PUSHED then
				if not BRUTE_ANIM then
					if (character_get_gender(LOCAL_PLAYER) == GENDER_TYPE_MALE) then
						customization_swap_player_rig( "cm_body.rig", "Brute" )
					else
						customization_swap_player_rig( "cf_body.rig", "Brute" )
					end
					sandboxplus_message("Animations set to Brute")
				else
					if (character_get_gender(LOCAL_PLAYER) == GENDER_TYPE_MALE) then
						customization_swap_player_rig( "cm_body.rig", "Plym" )
						player_super_powered(LOCAL_PLAYER, false)
					else
						customization_swap_player_rig( "cf_body.rig", "Plyf" )
						player_super_powered(LOCAL_PLAYER, false)  
					end
					sandboxplus_message("Animations set to normal player")
				end
				BRUTE_ANIM = not BRUTE_ANIM
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not CROUCH_PUSHED then
				if animation_set_swapped == 0 then
					if (character_get_gender(LOCAL_PLAYER) == GENDER_TYPE_MALE) then
						customization_swap_player_rig( "cm_body.rig", "Rollerblader" )
						player_super_powered(LOCAL_PLAYER, true)
					else
						customization_swap_player_rig( "cf_body.rig", "Rollerblader" )
						player_super_powered(LOCAL_PLAYER, true)
					end
					animation_set_swapped = 1
					sandboxplus_message("Animations set to Decker Specialist")
				else
					if (character_get_gender(LOCAL_PLAYER) == GENDER_TYPE_MALE) then
						customization_swap_player_rig( "cm_body.rig", "Plym" )
						player_super_powered(LOCAL_PLAYER, false)
					else
						customization_swap_player_rig( "cf_body.rig", "Plyf" )
						player_super_powered(LOCAL_PLAYER, false)  
					end
					animation_set_swapped = 0
					sandboxplus_message("Animations set to normal player")
				end
				CROUCH_PUSHED = true
			end



		elseif player_action_is_pressed("CBA_GAC_ACTION") then -- USE/ACTION E - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not USE_PUSHED then
				players_naked()
				player_parachute_wear_backpack( LOCAL_PLAYER, false )
				if coop_is_active() then
					player_parachute_wear_backpack( REMOTE_PLAYER, false )
				end
				if Outfit_Counter_Mission == 1 then
					sandboxplus_message("Outfit changed to When Good Heists Go Bad")
					customization_item_wear( "cm_suit_gatsuit", "cm_suit_gatsuit.cmeshx", "mGat_Body", false )
					customization_item_wear( "cm_hat_gatbobble", "Cm_hat_gatbobble.cmeshx", "Gatbobble", false )
				elseif Outfit_Counter_Mission == 2 then
					sandboxplus_message("Outfit changed to Nyteblade's Return")
					customization_outfit_wear("Cardinal")
				elseif Outfit_Counter_Mission == 3 then
					sandboxplus_message("Outfit changed to deckers.die Toilet")
					customization_item_wear("cm_toilet", "cm_toilet.cmeshx", "Material#9", false)
				elseif Outfit_Counter_Mission == 4 then
					sandboxplus_message("Outfit changed to deckers.die Blowup Doll")
					customization_item_wear("cm_blowupdoll", "cm_blowupdoll.cmeshx", "Blow_Up_Doll_A", false)
				elseif Outfit_Counter_Mission == 5 then
					sandboxplus_message("Outfit changed to deckers.die Cyber Avatar")
					customization_outfit_wear("Cyber Avatar")
				elseif Outfit_Counter_Mission == 6 then
					sandboxplus_message("Outfit changed to Murderbrawl XXXI")
					if (character_get_gender(LOCAL_PLAYER) == GENDER_TYPE_MALE) then
						customization_outfit_wear("Murderbrawl Wrestling Male")
					else
						customization_outfit_wear("Murderbrawl Wrestling Female")
					end
					if coop_is_active() then
						if (character_get_gender(REMOTE_PLAYER) == GENDER_TYPE_MALE) then
							customization_outfit_wear("Murderbrawl Wrestling Male")
						else
							customization_outfit_wear("Murderbrawl Wrestling Female")
						end
					end
				elseif Outfit_Counter_Mission == 7 then
					sandboxplus_message("Outfit changed to Cyrus Temple")
					customization_item_wear( "Cyrus Suit", "cyrus_hires.cmeshx", "Cyrus", false, SYNC_LOCAL )
					customization_item_wear( "Cyrus Head", "cyrus_hires_head.cmeshx", "Cyrus", false, SYNC_LOCAL )
					customization_swap_player_rig( "cyrus.rig", "PLYM", SYNC_LOCAL )
					if coop_is_active() then
						-- Put the remote player into a regular STAG soldier outfit.
						customization_item_wear("cm_stag", "cm_stag.cmeshx", "Stag_Body", false, SYNC_REMOTE)
						customization_item_wear("cm_hat_m_staghelmet", "cm_hat_m_staghelmet.cmeshx", "StagCommando_Body", false, SYNC_REMOTE)
					end
				elseif Outfit_Counter_Mission == 8 then
					sandboxplus_message("Outfit changed to Gangstas in Space")
					customization_restore_player_rig( SYNC_LOCAL )
					if coop_is_active() then
						customization_restore_player_rig( SYNC_REMOTE )
					end
					customization_outfit_wear("Lets Pretend Male A")
				elseif Outfit_Counter_Mission == 9 then
					sandboxplus_message("Outfit changed to Trailblazing")
					customization_outfit_wear("Trailblazing")
				end
				if Outfit_Counter_Mission == 9 then
					Outfit_Counter_Mission = 1
				else
					Outfit_Counter_Mission = Outfit_Counter_Mission + 1
				end
				customization_item_revert( SYNC_LOCAL ) --Needed or else stores no longer work after outfit change
				if coop_is_active() then
					customization_item_revert( SYNC_REMOTE )
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not USE_PUSHED then
				players_naked()
				player_parachute_wear_backpack( LOCAL_PLAYER, false )
				if coop_is_active() then
					player_parachute_wear_backpack( REMOTE_PLAYER, false )
				end
				if Outfit_Counter_Male == 1 then
					sandboxplus_message("Outfit changed to Safari Tour Guide")
					customization_outfit_wear("Impressions Male E")
				elseif Outfit_Counter_Male == 2 then
					sandboxplus_message("Outfit changed to Trendy and Modern")
					customization_outfit_wear("Impressions Male L")
				elseif Outfit_Counter_Male == 3 then
					sandboxplus_message("Outfit changed to South Beach")
					customization_outfit_wear("Impressions Male M")
				elseif Outfit_Counter_Male == 4 then
					sandboxplus_message("Outfit changed to Manhattan Style")
					customization_outfit_wear("Impressions Male O")
				elseif Outfit_Counter_Male == 5 then
					sandboxplus_message("Outfit changed to Steampunk Fighter")
					customization_outfit_wear("Nobody Loves Me Male A")
				elseif Outfit_Counter_Male == 6 then
					sandboxplus_message("Outfit changed to The Ex-Con")
					customization_outfit_wear("Nobody Loves Me Male B")
				elseif Outfit_Counter_Male == 7 then
					sandboxplus_message("Outfit changed to Slacker Chic")
					customization_outfit_wear("Nobody Loves Me Male C")
				elseif Outfit_Counter_Male == 8 then
					sandboxplus_message("Outfit changed to Punk Rock Anarchist")
					customization_outfit_wear("Nobody Loves Me Male D")
				elseif Outfit_Counter_Male == 9 then
					sandboxplus_message("Outfit changed to Stratagem Medley")
					customization_outfit_wear("Nobody Loves Me Male E")
				elseif Outfit_Counter_Male == 10 then
					sandboxplus_message("Outfit changed to Depressed Indie Kid")
					customization_outfit_wear("Nobody Loves Me Male G")
				elseif Outfit_Counter_Male == 11 then
					sandboxplus_message("Outfit changed to Steelport Hero")
					customization_outfit_wear("Lets Pretend Male C")
				elseif Outfit_Counter_Male == 12 then
					sandboxplus_message("Outfit changed to Total Animal")
					customization_outfit_wear("Lets Pretend Male G")
				elseif Outfit_Counter_Male == 13 then
					sandboxplus_message("Outfit changed to Master of the Seas")
					customization_outfit_wear("Lets Pretend Male H")
				elseif Outfit_Counter_Male == 14 then
					sandboxplus_message("Outfit changed to Leather and Lace Suit")
					customization_outfit_wear("Leather and Lace Male A")
				elseif Outfit_Counter_Male == 15 then
					sandboxplus_message("Outfit changed to Pleasure and Pain")
					customization_outfit_wear("Leather and Lace Male B")
				elseif Outfit_Counter_Male == 16 then
					sandboxplus_message("Outfit changed to Ladies Man")
					customization_outfit_wear("Leather and Lace Male K")
				elseif Outfit_Counter_Male == 17 then
					sandboxplus_message("Outfit changed to Road Hog")
					customization_outfit_wear("Leather and Lace Male L")
				elseif Outfit_Counter_Male == 18 then
					sandboxplus_message("Outfit changed to Disco Fever")
					customization_outfit_wear("Leather and Lace Male N")
				elseif Outfit_Counter_Male == 19 then
					sandboxplus_message("Outfit changed to Zero to Sixty")
					customization_outfit_wear("Leather and Lace Male O")
				elseif Outfit_Counter_Male == 20 then
					sandboxplus_message("Outfit changed to Electro DJ")
					customization_outfit_wear("Planet Saints Male D")
				elseif Outfit_Counter_Male == 21 then
					sandboxplus_message("Outfit changed to Street Smart")
					customization_outfit_wear("Planet Saints Male E")
				elseif Outfit_Counter_Male == 22 then
					sandboxplus_message("Outfit changed to Jump Shot")
					customization_outfit_wear("Planet Saints Male F")
				elseif Outfit_Counter_Male == 23 then
					sandboxplus_message("Outfit changed to Drug Dealer")
					customization_outfit_wear("Planet Saints Male G")
				elseif Outfit_Counter_Male == 24 then
					sandboxplus_message("Outfit changed to Hip Hop Legend")
					customization_outfit_wear("Planet Saints Outfit I")
				elseif Outfit_Counter_Male == 25 then
					sandboxplus_message("Outfit changed to Starving Arist")
					customization_outfit_wear("Planet Saints Outfit J")
				end
				if Outfit_Counter_Male == 25 then
					Outfit_Counter_Male = 1
				else
					Outfit_Counter_Male = Outfit_Counter_Male + 1
				end
				customization_item_revert( SYNC_LOCAL ) --Needed or else stores no longer work after outfit change
				if coop_is_active() then
					customization_item_revert( SYNC_REMOTE )
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not USE_PUSHED then
				players_naked()
				player_parachute_wear_backpack( LOCAL_PLAYER, false )
				if coop_is_active() then
					player_parachute_wear_backpack( REMOTE_PLAYER, false )
				end
				if Outfit_Counter_Female == 1 then
					sandboxplus_message("Outfit changed to Mod Style")
					customization_outfit_wear("Impressions Female N")
				elseif Outfit_Counter_Female == 2 then
					sandboxplus_message("Outfit changed to Urban Safari")
					customization_outfit_wear("Impressions Female O")
				elseif Outfit_Counter_Female == 3 then
					sandboxplus_message("Outfit changed to Black Tie Dress")
					customization_outfit_wear("Impressions Female P")
				elseif Outfit_Counter_Female == 4 then
					sandboxplus_message("Outfit changed to 80's Gone Wrong")
					customization_outfit_wear("Impressions Female Q")
				elseif Outfit_Counter_Female == 5 then
					sandboxplus_message("Outfit changed to Punkalicious")
					customization_outfit_wear("Nobody Loves Me Female B")
				elseif Outfit_Counter_Female == 6 then
					sandboxplus_message("Outfit changed to Goth Couture")
					customization_outfit_wear("Nobody Loves Me Female C")
				elseif Outfit_Counter_Female == 7 then
					sandboxplus_message("Outfit changed to Indie Kid")
					customization_outfit_wear("Nobody Loves Me Female D")
				elseif Outfit_Counter_Female == 8 then
					sandboxplus_message("Outfit changed to Wake and Bake")
					customization_outfit_wear("Nobody Loves Me Female E")
				elseif Outfit_Counter_Female == 9 then
					sandboxplus_message("Outfit changed to Steampunk Couture")
					customization_outfit_wear("Nobody Loves Me Female F")
				elseif Outfit_Counter_Female == 10 then
					sandboxplus_message("Outfit changed to Hippie Raver")
					customization_outfit_wear("Nobody Loves Me Female H")
				elseif Outfit_Counter_Female == 11 then
					sandboxplus_message("Outfit changed to Steelport Heroine")
					customization_outfit_wear("Lets Pretend Female C")
				elseif Outfit_Counter_Female == 12 then
					sandboxplus_message("Outfit changed to Combat Babe")
					customization_outfit_wear("Lets Pretend Female E")
				elseif Outfit_Counter_Female == 13 then
					sandboxplus_message("Outfit changed to Sexy Cowgirl")
					customization_outfit_wear("Lets Pretend Female G")
				elseif Outfit_Counter_Female == 14 then
					sandboxplus_message("Outfit changed to Cheer Captain")
					customization_outfit_wear("Lets Pretend Female H")
				elseif Outfit_Counter_Female == 15 then
					sandboxplus_message("Outfit changed to Punk Rock Stripper")
					customization_outfit_wear("Leather And Lace Female I")
				elseif Outfit_Counter_Female == 16 then
					sandboxplus_message("Outfit changed to Biker Chick")
					customization_outfit_wear("Leather And Lace Female J")
				elseif Outfit_Counter_Female == 17 then
					sandboxplus_message("Outfit changed to Catsuit")
					customization_outfit_wear("Leather And Lace Female K")
				elseif Outfit_Counter_Female == 18 then
					sandboxplus_message("Outfit changed to Oktoberfest Girl")
					customization_outfit_wear("Leather And Lace Female R")
				elseif Outfit_Counter_Female == 19 then
					sandboxplus_message("Outfit changed to Dark Maiden")
					customization_outfit_wear("Leather And Lace Female S")
				elseif Outfit_Counter_Female == 20 then
					sandboxplus_message("Outfit changed to Speedracer")
					customization_outfit_wear("Leather And Lace Female T")
				elseif Outfit_Counter_Female == 21 then
					sandboxplus_message("Outfit changed to Workin' the Streets")
					customization_outfit_wear("Planet Saints Female A")
				elseif Outfit_Counter_Female == 22 then
					sandboxplus_message("Outfit changed to Street Fighter")
					customization_outfit_wear("Planet Saints Female B")
				elseif Outfit_Counter_Female == 23 then
					sandboxplus_message("Outfit changed to Uptown Girl")
					customization_outfit_wear("Planet Saints Female C")
				elseif Outfit_Counter_Female == 24 then
					sandboxplus_message("Outfit changed to Beach Bum")
					customization_outfit_wear("Planet Saints Female D")
				elseif Outfit_Counter_Female == 25 then
					sandboxplus_message("Outfit changed to Jump Shot")
					customization_outfit_wear("Planet Saints Female E")
				elseif Outfit_Counter_Female == 26 then
					sandboxplus_message("Outfit changed to Gym Rat")
					customization_outfit_wear("Planet Saints Female F")
				elseif Outfit_Counter_Female == 27 then
					sandboxplus_message("Outfit changed to Art School")
					customization_outfit_wear("Planet Saints Female G")
				elseif Outfit_Counter_Female == 28 then
					sandboxplus_message("Outfit changed to Gangsta Girl")
					customization_outfit_wear("Planet Saints Female H")
				end
				if Outfit_Counter_Female == 28 then
					Outfit_Counter_Female = 1
				else
					Outfit_Counter_Female = Outfit_Counter_Female + 1
				end
				customization_item_revert( SYNC_LOCAL ) --Needed or else stores no longer work after outfit change
				if coop_is_active() then
					customization_item_revert( SYNC_REMOTE )
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not USE_PUSHED then
				if GRAVITY_ON then
					sandboxplus_message("Gravity disabled for player")
					human_gravity_enable(LOCAL_PLAYER, DISABLE)
					if COOP_COMMANDS and coop_is_active() then
						human_gravity_enable(REMOTE_PLAYER, DISABLE)
					end
				else
					sandboxplus_message("Gravity restored for player")
					human_gravity_enable(LOCAL_PLAYER, ENABLE)
					if COOP_COMMANDS and coop_is_active() then
						human_gravity_enable(REMOTE_PLAYER, ENABLE)
					end
				end
				GRAVITY_ON = not GRAVITY_ON
				USE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not USE_PUSHED then
				cash_add(10000)
				ding_finish_audio()
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not USE_PUSHED then
				if SANDBOX_TEAM == 1 then
					set_team(LOCAL_PLAYER, "Playas")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Playas")
					end
					sandboxplus_message("Team restored to Saints")
				elseif SANDBOX_TEAM == 2 then
					set_team(LOCAL_PLAYER, "Deckers")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Deckers")
					end
					sandboxplus_message("Team switched to Deckers")
				elseif SANDBOX_TEAM == 3 then
					set_team(LOCAL_PLAYER, "Luchadores")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Luchadores")
					end
					sandboxplus_message("Team switched to Luchadores")
				elseif SANDBOX_TEAM == 4 then
					set_team(LOCAL_PLAYER, "Morningstar")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Morningstar")
					end
					sandboxplus_message("Team switched to Morningstar")
				elseif SANDBOX_TEAM == 5 then
					set_team(LOCAL_PLAYER, "Police")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Police")
					end
					sandboxplus_message("Team switched to Police")
				elseif SANDBOX_TEAM == 6 then
					set_team(LOCAL_PLAYER, "STAG")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "STAG")
					end
					sandboxplus_message("Team switched to STAG")
				end
				if SANDBOX_TEAM < 6 then
					SANDBOX_TEAM = SANDBOX_TEAM + 1
				else
					SANDBOX_TEAM = 1
				end
				USE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not USE_PUSHED then
				if notoriety_get("deckers") == 5 then
					sandboxplus_message("Notoriety Deckers reset")
					notoriety_reset("deckers")
				else
					notoriety_set("deckers",(notoriety_get("deckers") +1))
					sandboxplus_message("Notoriety Deckers +1")
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not USE_PUSHED then

				if notoriety_get("luchadores") == 5 then
					notoriety_reset("luchadores")
					sandboxplus_message("Notoriety Luchadores reset")
				else
					notoriety_set("luchadores",(notoriety_get("luchadores") +1))
					sandboxplus_message("Notoriety Luchadores +1")
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not USE_PUSHED then
				if notoriety_get("Morningstar") == 5 then
					notoriety_reset("Morningstar")
					sandboxplus_message("Notoriety Morningstar reset")
				else
					notoriety_set("Morningstar",(notoriety_get("Morningstar") +1))
					sandboxplus_message("Notoriety Morningstar +1")
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not USE_PUSHED then
				if notoriety_get("Police") == 5 then
					notoriety_reset("Police")
					sandboxplus_message("Notoriety Police reset")
				else
					notoriety_set("Police",(notoriety_get("Police") +1))
					sandboxplus_message("Notoriety Police +1")
				end
				--USE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not USE_PUSHED then
				if NOTORIETY_ZERO then
					notoriety_set_max("police", 0)
					notoriety_set_max("deckers", 0)
					notoriety_set_max("luchadores", 0)
					notoriety_set_max("Morningstar", 0)
					sandboxplus_message("Notoriety locked at zero")
				else
					notoriety_set_max("police", 5)
					notoriety_set_max("deckers", 5)
					notoriety_set_max("luchadores", 5)
					notoriety_set_max("Morningstar", 5)
					sandboxplus_message("Notoriety lock removed")
				end
				NOTORIETY_ZERO = not NOTORIETY_ZERO
				USE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not USE_PUSHED then
				notoriety_restricted_zones_enable(RESTRICTED_ZONE_NOTORIETY)
				if RESTRICTED_ZONE_NOTORIETY == true then
					sandboxplus_message("Restricted Zone Notoriety Enabled")
				else
					sandboxplus_message("Restricted Zone Notoriety Disabled")
				end
				RESTRICTED_ZONE_NOTORIETY = not RESTRICTED_ZONE_NOTORIETY
				USE_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not USE_PUSHED then
				--UNUSED
				USE_PUSHED = true
			end




		elseif player_action_is_pressed("CBA_OFC_PICKUP_RELOAD") then -- R(eload) - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_TWO == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "dildo_bat", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Penetrator")
				elseif SLOT_TWO == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "dildo_bat", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Killbane_gloves", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Apocafists")
				elseif SLOT_TWO == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Killbane_gloves", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "chainsaw", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Chainsaw lvl1")
				elseif SLOT_TWO == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "chainsaw", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "baseball_bat", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Baseball bat lvl1")
				elseif SLOT_TWO == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "baseball_bat", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "baseball_bat", 1, true, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary Baseball bat lvl2")
				elseif SLOT_TWO == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "baseball_bat", 1, true, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "decker_sword", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Decker sword")
				elseif SLOT_TWO == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "decker_sword", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "stun_gun", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Stun gun")
				elseif SLOT_TWO == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "stun_gun", 1, true, true, false, true, WEAPON_LEVEL1)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Melee weapon removed and original restored")
				end
				if SLOT_TWO < 8 then
					SLOT_TWO = SLOT_TWO + 1
				else
					SLOT_TWO = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_THREE == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Kobra lvl1")
				elseif SLOT_THREE == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary Kobra lvl2")
				elseif SLOT_THREE == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary Kobra lvl3")
				elseif SLOT_THREE == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary Kobra lvl4")
				elseif SLOT_THREE == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Police", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary 45 Shepherd lvl1")
				elseif SLOT_THREE == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary 45 Shepherd lvl2")
				elseif SLOT_THREE == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary 45 Shepherd lvl3")
				elseif SLOT_THREE == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary 45 Shepherd lvl4")
				elseif SLOT_THREE == 9 then
					crib_weapon_add_enable()
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Pistol-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					sandboxplus_message("Temporary Pistol removed and original restored")
				end
				if SLOT_THREE < 9 then
					SLOT_THREE = SLOT_THREE + 1
				else
					SLOT_THREE = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_FOUR == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary TEK Z-10 lvl1")
				elseif SLOT_FOUR == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary TEK Z-10 lvl2")
				elseif SLOT_FOUR == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary TEK Z-10 lvl3")
				elseif SLOT_FOUR == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary TEK Z-10 lvl4")
				elseif SLOT_FOUR == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Gang", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary D4TH Blossom lvl1")
				elseif SLOT_FOUR == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary D4TH Blossom lvl2")
				elseif SLOT_FOUR == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary D4TH Blossom lvl3")
				elseif SLOT_FOUR == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary D4TH Blossom lvl4")
				elseif SLOT_FOUR == 9 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Storm", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "SMG-Cyberspace", 1, UNLIMITED_AMMO_CYCLE, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Cyber blasters")
				elseif SLOT_FOUR == 10 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "SMG-Cyberspace", 1, true, true, DUAL_WIELD_CYCLE, true, WEAPON_LEVEL1)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Pistol removed")
				end
				if SLOT_FOUR < 10 then
					SLOT_FOUR = SLOT_FOUR + 1
				else
					SLOT_FOUR = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_FIVE == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Grave Digger lvl1")
				elseif SLOT_FIVE == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary Grave Digger lvl2")
				elseif SLOT_FIVE == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary Grave Digger lvl3")
				elseif SLOT_FIVE == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary Grave Digger lvl4")
				elseif SLOT_FIVE == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary AS3 Ultimax lvl1")
				elseif SLOT_FIVE == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary AS3 Ultimax lvl2")
				elseif SLOT_FIVE == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary AS3 Ultimax lvl3")
				elseif SLOT_FIVE == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary AS3 Ultimax lvl4")
				elseif SLOT_FIVE == 9 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-Police", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary S3X Hammer lvl1")
				elseif SLOT_FIVE == 10 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary S3X Hammer lvl2")
				elseif SLOT_FIVE == 11 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary S3X Hammer lvl3")
				elseif SLOT_FIVE == 12 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary S3X Hammer lvl4")
				elseif SLOT_FIVE == 13 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Shotgun-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Shotgun removed")
				end
				if SLOT_FIVE < 13 then
					SLOT_FIVE = SLOT_FIVE + 1
				else
					SLOT_FIVE = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_END) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_SIX == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary K-8 Krukov lvl1")
				elseif SLOT_SIX == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary K-8 Krukov lvl2")
				elseif SLOT_SIX == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary K-8 Krukov lvl3")
				elseif SLOT_SIX == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary K-8 Krukov lvl4")
				elseif SLOT_SIX == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-Gang", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary AR-55 lvl1")
				elseif SLOT_SIX == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary AR-55 lvl2")
				elseif SLOT_SIX == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary AR-55 lvl3")
				elseif SLOT_SIX == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary AR-55 lvl4")
				elseif SLOT_SIX == 9 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-NG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Give temporary Viper lvl1")
				elseif SLOT_SIX == 10 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Give temporary Viper lvl2")
				elseif SLOT_SIX == 11 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Give temporary Viper lvl3")
				elseif SLOT_SIX == 12 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Give temporary Viper lvl4")
				elseif SLOT_SIX == 13 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Rifle-STAG", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Rifle removed")
				end
				if SLOT_SIX < 13 then
					SLOT_SIX = SLOT_SIX + 1
				else
					SLOT_SIX = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not RELOAD_PUSHED then
				crib_weapon_add_disable()     
				if SLOT_SEVEN == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Rocket Launcher lvl1")
				elseif SLOT_SEVEN == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Rocket Launcher lvl2")
				elseif SLOT_SEVEN == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Rocket Launcher lvl3")
				elseif SLOT_SEVEN == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Rocket Launcher lvl4")
				elseif SLOT_SEVEN == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Explosive-RocketLauncher", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Satchel lvl1")
				elseif SLOT_SEVEN == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Satchel lvl2")
				elseif SLOT_SEVEN == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Satchel lvl3")
				elseif SLOT_SEVEN == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Satchel lvl4")
				elseif SLOT_SEVEN == 9 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "satchel", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Explosive removed")
				end
				if SLOT_SEVEN < 9 then
					SLOT_SEVEN = SLOT_SEVEN + 1
				else
					SLOT_SEVEN = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_EIGHT == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-CyberCannon", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Cyber cannon")
				elseif SLOT_EIGHT == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-CyberCannon", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-SonicGun", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Sonic boom")
				elseif SLOT_EIGHT == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-SonicGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Airstrike lvl1")
				elseif SLOT_EIGHT == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Airstrike lvl2")
				elseif SLOT_EIGHT == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Airstrike lvl3")
				elseif SLOT_EIGHT == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Airstrike lvl4")
				elseif SLOT_EIGHT == 7 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Airstrike", 1, true, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Reaper drone lvl1")
				elseif SLOT_EIGHT == 8 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("Reaper drone lvl2")
				elseif SLOT_EIGHT == 9 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("Reaper drone lvl3")
				elseif SLOT_EIGHT == 10 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("Reaper drone lvl4")
				elseif SLOT_EIGHT == 11 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-Drone", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("RC gun lvl1")
				elseif SLOT_EIGHT == 12 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("RC gun lvl2")
				elseif SLOT_EIGHT == 13 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("RC gun lvl3")
				elseif SLOT_EIGHT == 14 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("RC gun lvl4")
				elseif SLOT_EIGHT == 15 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-RCVehicleGun", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("McManus lvl1")
				elseif SLOT_EIGHT == 16 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					sandboxplus_message("McManus lvl2")
				elseif SLOT_EIGHT == 17 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL2)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					sandboxplus_message("McManus lvl3")
				elseif SLOT_EIGHT == 18 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL3)
					inv_weapon_add_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					sandboxplus_message("McManus lvl4")
				elseif SLOT_EIGHT == 19 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "Special-SniperRifle", 1, UNLIMITED_AMMO_CYCLE, true, false, true, WEAPON_LEVEL4)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Explosive removed")
				end
				if SLOT_EIGHT < 19 then
					SLOT_EIGHT = SLOT_EIGHT + 1
				else
					SLOT_EIGHT = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not RELOAD_PUSHED then
				crib_weapon_add_disable()
				if SLOT_TEMP == 1 then
					inv_weapon_add_temporary(LOCAL_PLAYER, "brute_minigun", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Minigun")
				elseif SLOT_TEMP == 2 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "brute_minigun", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "brute_flamethrower", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Flamthrower")
				elseif SLOT_TEMP == 3 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "brute_flamethrower", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "TempPickup-LuchadoreGrenadeLauncher", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("GL G20")
				elseif SLOT_TEMP == 4 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "TempPickup-LuchadoreGrenadeLauncher", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "RocketHammer", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("Rocket hammer")
				elseif SLOT_TEMP == 5 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "RocketHammer", 1, true, true, false, true, WEAPON_LEVEL1)
					inv_weapon_add_temporary(LOCAL_PLAYER, "RiotShield", 1, true, true, false, true, WEAPON_LEVEL1)
					sandboxplus_message("riot shield")
				elseif SLOT_TEMP == 6 then
					inv_weapon_remove_temporary(LOCAL_PLAYER, "RiotShield", 1, true, true, false, true, WEAPON_LEVEL1)
					crib_weapon_add_enable()
					sandboxplus_message("Temporary Temp weapon removed")
                                        end
				if SLOT_TEMP < 6 then
					SLOT_TEMP = SLOT_TEMP + 1
				else
					SLOT_TEMP = 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not RELOAD_PUSHED then
				if not DUAL_WIELD_CYCLE then
					sandboxplus_message("Dual Wield enabled for weapon cycle")
				else
					sandboxplus_message("Single Wield enabled for weapon cycle")
				end
				DUAL_WIELD_CYCLE = not DUAL_WIELD_CYCLE
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not RELOAD_PUSHED then
				if not UNLIMITED_AMMO_CYCLE then
					sandboxplus_message("Unlimited ammo enabled for weapon cycle")
				else
					sandboxplus_message("Limited ammo enabled for weapon cycle")
				end
				UNLIMITED_AMMO_CYCLE = not UNLIMITED_AMMO_CYCLE
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not RELOAD_PUSHED then
				inv_item_remove_all("#FOLLOWER1#")
				inv_item_remove_all("#FOLLOWER2#")
				inv_item_remove_all("#FOLLOWER3#")
				if (flwr_weaps == 1) then
					inv_item_add("SMG-Gang",10,"#FOLLOWER1#",true)
					inv_item_add("Shotgun-Gang",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-Gang",10,"#FOLLOWER3#",true)
					sandboxplus_message("Followers armed with gang weapons.") --Back in the hood
				elseif (flwr_weaps == 2) then
					inv_item_add("SMG-Storm",10,"#FOLLOWER1#",true)
					inv_item_add("Shotgun-Police",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-NG",10,"#FOLLOWER3#",true)
					sandboxplus_message("Followers armed with police weapons.") --Roger that!
				elseif (flwr_weaps == 3) then
					inv_item_add("SMG-Cyberspace",10,"#FOLLOWER1#",true)
					inv_item_add("Shotgun-Stag",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-Stag",10,"#FOLLOWER3#",true)
					sandboxplus_message("Followers armed with laser weapons.") --Pew, pew!
				elseif (flwr_weaps == 4) then
					sandboxplus_message("Followers fight with bare fists.") --Bare knuckles
				end
				if (flwr_weaps == 4) then
					flwr_weaps = 1
				else
					flwr_weaps = flwr_weaps + 1
				end
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not RELOAD_PUSHED then
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					set_attack_peds_flag("#FOLLOWER1#", true)
					set_attack_peds_flag("#FOLLOWER2#", true)
					set_attack_peds_flag("#FOLLOWER3#", true)
					sandboxplus_message("Followers will aggressively attack all pedestrians")
				else
					set_attack_peds_flag("#FOLLOWER1#", false)
					set_attack_peds_flag("#FOLLOWER2#", false)
					set_attack_peds_flag("#FOLLOWER3#", false)
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					ai_force_team_idle("None")
					sandboxplus_message("Follower behavior restored to normal")
				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				RELOAD_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not RELOAD_PUSHED then
				if npc_is_in_party("#FOLLOWER1#") then		
					character_set_over_the_shoulder("#FOLLOWER1#", true)
					npc_go_idle("#FOLLOWER1#")
					set_animation_state("#FOLLOWER1#", "crouch")
					set_unrecruitable_flag("#FOLLOWER1#", true)
					party_dismiss("#FOLLOWER1#")
					set_ignore_ai_flag("#FOLLOWER1#", true)
					sandboxplus_message("Over-shoulder carry ENABLED.\nGrab the crouching follower like if you were grabing a live-shield.")
				else
					sandboxplus_message("You need to have at least one follower.")
				end
				RELOAD_PUSHED = true
			end


		elseif player_action_is_pressed("CBA_OFC_MELEE_NUT_SHOT") then -- F (melee/horn) - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not MELEE_PUSHED then
				-- REPAIR CURRENT VEHICLE
				if character_is_in_vehicle(LOCAL_PLAYER) then
					sandboxplus_message("Player vehicle repaired")
					vehicle_repair( get_char_vehicle_name(LOCAL_PLAYER) )
				else
					sandboxplus_message("Repair vehicle FAILED")
				end
				if COOP_COMMANDS and coop_is_active() then
					if character_is_in_vehicle(REMOTE_PLAYER) then
						vehicle_repair( get_char_vehicle_name(REMOTE_PLAYER) )
					end
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not MELEE_PUSHED then
				-- SET CURRENT VEHICLE INVULNERABLE/VULNERABLE
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_INVULNERABLE then
						sandboxplus_message("Player vehicle is now invulnerable")
						vehicle_set_invulnerable( get_char_vehicle_name(LOCAL_PLAYER) )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_set_invulnerable( get_char_vehicle_name(REMOTE_PLAYER) )
							end
						end
					else
						sandboxplus_message("Player vehicle is now vulnerable")
						vehicle_set_vulnerable( get_char_vehicle_name(LOCAL_PLAYER) )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_set_vulnerable( get_char_vehicle_name(REMOTE_PLAYER) )
							end
						end
					end
					VEHICLE_INVULNERABLE = not VEHICLE_INVULNERABLE
				else
					sandboxplus_message("Toggle vehicle invulnerability FAILED")
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not MELEE_PUSHED then
				-- SET CURRENT VEHICLE INFINITE MASS
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_MASS then
						sandboxplus_message("Player vehicle now has infinite mass")
						vehicle_infinite_mass( get_char_vehicle_name(LOCAL_PLAYER),true )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_infinite_mass( get_char_vehicle_name(REMOTE_PLAYER),true )
							end
						end
					else
						sandboxplus_message("Player vehicle mass is now normal")
						vehicle_infinite_mass( get_char_vehicle_name(LOCAL_PLAYER),false )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_infinite_mass( get_char_vehicle_name(REMOTE_PLAYER),false )
							end
						end
					end
					VEHICLE_MASS = not VEHICLE_MASS
				else
					sandboxplus_message("Toggle vehicle infinite mass FAILED")
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not MELEE_PUSHED then
				-- SET CURRENT VEHICLE CANNOT BE FLIPPED
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_NOFLIP then
						vehicle_suppress_flipping( get_char_vehicle_name(LOCAL_PLAYER),true )
						sandboxplus_message("Player vehicle can no longer be flipped")
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_suppress_flipping( get_char_vehicle_name(REMOTE_PLAYER),true )
							end
						end
					else
						sandboxplus_message("Player vehicle can now be flipped")
						vehicle_suppress_flipping( get_char_vehicle_name(LOCAL_PLAYER),false )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_suppress_flipping( get_char_vehicle_name(REMOTE_PLAYER),false )
							end
						end
					end
					VEHICLE_NOFLIP = not VEHICLE_NOFLIP
				else
					sandboxplus_message("Toggle vehicle supress flipping FAILED")
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not MELEE_PUSHED then
				-- SET CURRENT VEHICLE UNJACKABLE
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_LOCKED then
						sandboxplus_message("Player vehicle can no longer be car jacked")
						set_unjackable_flag( get_char_vehicle_name(LOCAL_PLAYER),true )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								set_unjackable_flag( get_char_vehicle_name(REMOTE_PLAYER),true )
							end
						end
					else
						sandboxplus_message("Player vehicle can now be car jacked")
						set_unjackable_flag( get_char_vehicle_name(LOCAL_PLAYER),false )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								set_unjackable_flag( get_char_vehicle_name(REMOTE_PLAYER),false )
							end
						end
					end
					VEHICLE_LOCKED = not VEHICLE_LOCKED
				else
					sandboxplus_message("Toggle vehicle unjackable status FAILED")
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not MELEE_PUSHED then
				local myride = get_char_vehicle_name(LOCAL_PLAYER)
				local driver = vehicle_get_driver(myride)
				if (passenger_activated == 0) then
					--if (1) passenger mode is disabled and (2) you're on foot... enable passenger mode.
					set_unjackable_flag( myride, false ) -- Useful when you're entering the same car for the second time and keybind is tapped inside a vehicle.
					vehicle_set_crazy(myride, false)
					vehicle_suppress_npc_exit(myride, false)
					player_force_vehicle_seat(LOCAL_PLAYER, 1) -- Force the player take passenger seat.
					sandboxplus_message("Passenger mode ENABLED.\nFind a vehicle, enter it and wait for your followers. Then tap this keybind again.")
					passenger_activated = 1 -- Prepare your car for riding as a passenger in a proper mode. Your current one is very buggy.
					-- IMPROVEMENT IDEA NO 1: maybe make the function automatically enter "drive calmly" mode after all followers are in?
					-- And clear "no npc exit", "vehicle crazy" mode automatically?
				elseif (passenger_activated == 1) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == "#FOLLOWER#") then
					--if (1) passenger mode is enabled and (2) you're in a car and (3)you're driver is your follower ... activate riding as a passenger.
					ai_force_team_idle("None")		-- Helps in a runaways.
					set_unjackable_flag( myride, true )	-- I decided to turn it on.
					vehicle_set_crazy(myride, false)	-- It *should* help a bit, but no guaranty on that!
					vehicle_suppress_npc_exit(myride, true)	-- Prevents player and his followers from forced exiting the vehicle
					set_ignore_ai_flag("#FOLLOWER2#", true)	-- Make followers careless about enemies attacks and drive calmly
					set_ignore_ai_flag("#FOLLOWER3#", true)
					set_ignore_ai_flag("#FOLLOWER1#", true)
					vehicle_set_crazy(myride, true) 	-- We have to be in a rush! Driver doesn't obey to traffic law.
					vehicle_max_speed(myride, 70.0) 	-- Caps the top-speed of car. Prevents windshield cannons and going so fast so you can't aim at anything.
					sandboxplus_message("SMOOTH RIDE mode.")
					passenger_activated = 2 		-- Next time player taps passenger mode combination he's gonna activate "drive aggresively" mode.
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == LOCAL_PLAYER) then
					-- if (1) passenger mode is enabled (2) you're in a car and (3) you're a driver.... don't let it execute the instruction below ;)
					sandboxplus_message("Exit the vehicle, enter it again and wait for your followers. Tap this keybind again to begin riding as a passenger!")
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver ~= "#FOLLOWER#") and (driver ~= LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) you're in a car and (3) you DON'T have a follower as a driver and (4) you're not a driver ... force followers to appear in player's car.
					-- This piece of code is used for situation when - for whatever reason - your driver (or some of your followers) didn't find their ways
					-- to player's vehicle. It might be because they decided to take another car or are just too far away for you to wait.
					vehicle_suppress_npc_exit(myride, false) 		--Temporary lock. Maybe it's useless, maybe it's not.
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, false)	-- Locking players ability to get out of the car. This is just temporary.
					vehicle_exit_teleport(driver) 				-- Two things to describe here. As I still don't get the difference between "#FOLLOWER#" and "#FOLLOWER1#" 
					vehicle_exit_teleport("#FOLLOWER#")			-- and this function is kinda crucial for the whole passenger-thing, I decided to make it as as safe as it gets.
					vehicle_exit_teleport("#FOLLOWER1#") 			-- Second: it's purpose is to make followers exit any car they're currently in and rearrange their appearance 
					vehicle_exit_teleport("#FOLLOWER2#") 			-- in player's car. It takes a tic to do that and I think it works very well! We're forcing evey one of
					vehicle_exit_teleport("#FOLLOWER3#") 			-- them - even those still sitting in your car as they should - to prevent seat-blocking.
					--delay(1.0)						-- You may want to enable that line to see if homies really exit their cars before appearing in player's one. Useful for hunting down "#FOLLOWER#" stuff!
					vehicle_enter_teleport("#FOLLOWER#", myride,0) 		-- Here we're forcing - already on-foot - followers to enter player's car.
					vehicle_enter_teleport("#FOLLOWER2#", myride,2)		-- Also: #FOLLOWER# works fine so MAYBE there's no need for "#FOLLOWER1#?
					vehicle_enter_teleport("#FOLLOWER3#", myride,3)
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)	-- If player could exit the car before teleporting homies, function might flopped!
					vehicle_suppress_npc_exit(myride, true)			-- Force the followers to stay in car.
					passenger_activated = 1 				-- Again we're in that weird mode where followers drive the car for you but it's a mode that isn't fun even for a bit.
												-- IMPROVEMENT IDEA NO 1 for the second time!
					sandboxplus_message("Followers teleported to your car. Tap this keybind again to begin riding as a passenger!")					
				elseif (passenger_activated ~= 0) and not character_is_in_vehicle(LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) player is in foot then... quit the passenger mode and become a driver again!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- If player want to leave the passenger mode during "drive calmly" phase,
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- we have to give them back their original behavior.
					set_ignore_ai_flag("#FOLLOWER1#", false)
					set_ignore_ai_flag("#FOLLOWER#", false)			-- Once again: difference between "#FOLLOWER1#" and "#FOLLOWER#" is a big mystery for me. Sometimes it works, sometime don't.
					player_force_vehicle_seat(LOCAL_PLAYER, 0)		-- Make the player to take the driver's seat.
					vehicle_exit_teleport(driver) 				-- Another longer description. As you might remember, we made the car "unexitable" (via vehicle_suppress_npc_exit()).
					vehicle_exit_teleport("#FOLLOWER#") 			-- If those lines over here didn't exists, player who quits passenger mode wouldn't have his followers back
					vehicle_exit_teleport("#FOLLOWER1#") 			-- because it's impossible to clear "unexitable" flag while on-foot: we can only adress a function to a named
					vehicle_exit_teleport("#FOLLOWER2#") 			-- vehicle - it means player's current - and there's nothing like "#PLAYERS_LAST_CAR#. So here we're
					vehicle_exit_teleport("#FOLLOWER3#") 			-- forcing followers to leave via teleporting them. Unexitable flag will be activated when player enters the car again as a passenger.
					passenger_activated = 0
					sandboxplus_message("Passenger mode DISABLED.\nIf something is wrong with your followers AI - press this keybind again. If that doesn't help, dismiss and recruit followers again.")
				elseif (passenger_activated == 2) and character_is_in_vehicle(LOCAL_PLAYER) then
					passenger_activated = 1
					vehicle_set_crazy(myride, false)			-- It *should* help a bit, but no guaranty on that!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- Make the followers use their "gang deffensive" AI again. Now they will return fire, pull over
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- attacking enemies but - since "vehicle_surpress_npc_exit()" is still on - they won't leave
					set_ignore_ai_flag("#FOLLOWER1#", false) 		-- the player's car. Drive-by, baby.
					vehicle_set_crazy(myride,true)				-- It *should* help a bit, but no guaranty on that!
					sandboxplus_message("DRIVE-BY mode.")
				else 
					sandboxplus_message("You're not in a car, you don't have a driver yet, or something else went wrong.") -- Player shouldn't see this message too often.
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not MELEE_PUSHED then
				if POLICE_SHOOT_FROM_VEHICLES then
					sandboxplus_message("Police shooting from vehicles disabled")
				else
					sandboxplus_message("Police will now shoot from vehicles at 3 notoriety or higher")
				end
				POLICE_SHOOT_FROM_VEHICLES = not POLICE_SHOOT_FROM_VEHICLES
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not MELEE_PUSHED then

				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not MELEE_PUSHED then
				vehicle_detonate_random_parked_car()
				sandboxplus_message("Random parked car go BOOM")
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not MELEE_PUSHED then
				-- Toggle Day/Night Cycle
				ding_finish_audio()
				if TOD_State then
					sandboxplus_message("Day Night cycle reverted back to static")
				else
					sandboxplus_message("Day Night cycle is now dynamic and changes with gametime")
				end
				TOD_State = not TOD_State
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not MELEE_PUSHED then
				if TOD_Count == 1 then
					sandboxplus_message("Time of day set to noon")
					set_time_of_day(14, 30) --advance TOD to noon
				elseif TOD_Count == 2 then
					sandboxplus_message("Time of day set to sunset")
					set_time_of_day(21, 00) --advance TOD to sunset
				elseif TOD_Count == 3 then
					sandboxplus_message("Time of day set to night")
					set_time_of_day(05, 00) --advance TOD to night
				else
					sandboxplus_message("Time of day set to sunrise")
					set_time_of_day(09, 30) --advance TOD to sunrise
				end
				if TOD_Count < 4 then
					TOD_Count = TOD_Count + 1
				else
					TOD_Count = 1
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not MELEE_PUSHED then
				--sandboxplus_message("ALTERNATE TIME OF DAY TEMPORARILY DISABLED SINCE IT BREAKS SPAWNING")
				if Alt_TOD_Count == 1 then
					set_time_of_day(23, 30)
					delay(1.0)
					set_time_of_day(23, 30)
					sandboxplus_message("Set Virtual Reality time of day")
				elseif Alt_TOD_Count == 2 then
					set_time_of_day(16, 00)
					delay(1.0)
					set_time_of_day(16, 00)
					sandboxplus_message("Set Mars time of day")
				elseif Alt_TOD_Count == 3 then
					set_time_of_day(10, 00)
					delay(1.0)
					set_time_of_day(10, 00)
					sandboxplus_message("Set Alt Sunrise 1")
				elseif Alt_TOD_Count == 4 then
					set_time_of_day(8, 00)
					delay(1.0)
					set_time_of_day(8, 00)
					sandboxplus_message("Set Alt Sunrise 2")
				elseif Alt_TOD_Count == 5 then
					set_time_of_day(15, 00)
					delay(1.0)
					set_time_of_day(15, 00)
					sandboxplus_message("Set Alt Noon 1")
				elseif Alt_TOD_Count == 6 then
					set_time_of_day(17, 00)
					delay(1.0)
					set_time_of_day(17, 00)
					sandboxplus_message("Set Alt Noon 2")
				elseif Alt_TOD_Count == 7 then
					set_time_of_day(21, 30)
					delay(1.0) 
					set_time_of_day(21, 30)
					sandboxplus_message("Set Alt Sunset 1")
				elseif Alt_TOD_Count == 8 then
					set_time_of_day(5, 30)
					delay(1.0)
					set_time_of_day(5, 30)
					sandboxplus_message("Set Alt Night 1")
				elseif Alt_TOD_Count == 9 then
					set_time_of_day(3, 30)
					delay(1.0)
					set_time_of_day(3, 30)
					sandboxplus_message("Set Alt Night 2")
				end
				if Alt_TOD_Count < 9 then
					Alt_TOD_Count = Alt_TOD_Count + 1
				else
					Alt_TOD_Count = 1
				end
				TOD_State = false -- stop TOD cycle
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not MELEE_PUSHED then
				-- RESHUFFLE MUSIC FOR ALL TABLES
				sandboxplus_message("All radio and custom playlists reshuffled")
				randomize_music = "on"
				Create_Radio_Station_Tables(randomize_music)
				MELEE_PUSHED = true
			end



		elseif player_action_is_pressed("CBA_GAC_GRENADE_SWITCH") then -- G (grenade change) - ON-FOOT RADIO
			if player_action_is_pressed(B_INSERT) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Mixx")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("K12")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Krunch")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Klassic")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Swim")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Kabron")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Krhyme")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Genx")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Mission")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not GRENADE_PUSHED then
				local mixtest = #MixtapeData
				if mixtest > 0 then
					kill_radio_music()
					advance_next_song("Mixtape")
				else
					sandboxplus_message("No Custom Playlist tracks selected. Edit sr3_city.lua and set mixtape to true for your choices")
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("Commercial")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not GRENADE_PUSHED then
				kill_radio_music()
				advance_next_song("News")
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not GRENADE_PUSHED then
				sandboxplus_message("RADIO OFF")
				kill_radio_music()
				current_radio_song = ""
				GRENADE_PUSHED = true
			end





		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_1") then -- Weapon Select 1 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not ONE_PUSHED then
				sandbox_cutscene("01_in")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not ONE_PUSHED then
				sandbox_cutscene("02_in")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not ONE_PUSHED then
				sandbox_cutscene("02_out")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not ONE_PUSHED then
				sandbox_cutscene("03_out")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not ONE_PUSHED then
				sandbox_cutscene("05_in")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not ONE_PUSHED then
				sandbox_cutscene("05_out")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not ONE_PUSHED then
				sandbox_cutscene("06_in")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not ONE_PUSHED then
				sandbox_cutscene("06_mid")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not ONE_PUSHED then
				sandbox_cutscene("06_out1")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not ONE_PUSHED then
				sandbox_cutscene("06_out2")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not ONE_PUSHED then
				sandbox_cutscene("07_in")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not ONE_PUSHED then
				sandbox_cutscene("07_out")
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not ONE_PUSHED then
				sandbox_cutscene("08_in")
				ONE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_2") then -- Weapon Select 2 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not TWO_PUSHED then
				sandbox_cutscene("08_out")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not TWO_PUSHED then
				sandbox_cutscene("09_in")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not TWO_PUSHED then
				sandbox_cutscene("09_out")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not TWO_PUSHED then
				sandbox_cutscene("10_in")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_END) and not TWO_PUSHED then
				sandbox_cutscene("10_mid")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not TWO_PUSHED then
				sandbox_cutscene("10_out")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not TWO_PUSHED then
				sandbox_cutscene("11_in")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not TWO_PUSHED then
				sandbox_cutscene("11_out")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not TWO_PUSHED then
				sandbox_cutscene("12_in")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not TWO_PUSHED then
				sandbox_cutscene("12_out")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not TWO_PUSHED then
				sandbox_cutscene("13_in")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not TWO_PUSHED then
				sandbox_cutscene("13_out")
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not TWO_PUSHED then
				sandbox_cutscene("14_in")
				TWO_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_3") then -- Weapon Select 3 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not THREE_PUSHED then
				sandbox_cutscene("14_out")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not THREE_PUSHED then
				sandbox_cutscene("15_in")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not THREE_PUSHED then
				sandbox_cutscene("15_out")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not THREE_PUSHED then
				sandbox_cutscene("16_in")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not THREE_PUSHED then
				sandbox_cutscene("16_out")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not THREE_PUSHED then
				sandbox_cutscene("17_in")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not THREE_PUSHED then
				sandbox_cutscene("17_mid")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not THREE_PUSHED then
				sandbox_cutscene("17_out")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not THREE_PUSHED then
				sandbox_cutscene("17_out_pt2")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not THREE_PUSHED then
				sandbox_cutscene("18_in")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not THREE_PUSHED then
				sandbox_cutscene("18_out")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not THREE_PUSHED then
				sandbox_cutscene("19_in")
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not THREE_PUSHED then
				sandbox_cutscene("19_out")
				THREE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_4") then -- Weapon Select 4 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not FOUR_PUSHED then
				sandbox_cutscene("20_in")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not FOUR_PUSHED then
				sandbox_cutscene("20_out")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not FOUR_PUSHED then
				sandbox_cutscene("21_in")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not FOUR_PUSHED then
				sandbox_cutscene("21_out")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_END) and not FOUR_PUSHED then
				sandbox_cutscene("22_in")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not FOUR_PUSHED then
				sandbox_cutscene("22_out1")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not FOUR_PUSHED then
				sandbox_cutscene("22_out2")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not FOUR_PUSHED then
				sandbox_cutscene("23_in")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not FOUR_PUSHED then
				sandbox_cutscene("23_out")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not FOUR_PUSHED then
				sandbox_cutscene("24_out")
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not FOUR_PUSHED then
				-- UNUSED
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not FOUR_PUSHED then
				-- UNUSED
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not FOUR_PUSHED then
				-- UNUSED
				FOUR_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_5") then -- Weapon Select 5 - ZONE SWAPS AND WORLD STATE
			if player_action_is_pressed(B_INSERT) and not FIVE_PUSHED then
				safeword_toggle(Safeword_State)
				if Safeword_State == true then
					sandboxplus_message("Safeword changed to Saints crib")
				else
					sandboxplus_message("Safeword changed to BDSM club")
				end
				Safeword_State = not Safeword_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not FIVE_PUSHED then
				nukeplant_toggle(Nukeplant_State)
				if Nukeplant_State == true then
					sandboxplus_message("Nukeplant changed to Saints crib")
				else
					sandboxplus_message("Nukeplant changed to Decker Reactor")
				end
				Nukeplant_State = not Nukeplant_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not FIVE_PUSHED then
				threecount_toggle(ThreeCount_State)
				if ThreeCount_State == true then
					sandboxplus_message("Three Count changed to Saints crib")
				else
					sandboxplus_message("Three Count changed to Luchadore Casino")
				end
				ThreeCount_State = not ThreeCount_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not FIVE_PUSHED then
				-- Saints HQ ZONES
				saintshq_toggle(SaintsHQ_Count)
				if SaintsHQ_Count == 1 then
					sandboxplus_message("Saints HQ zone swapped to Morningstar colors")
					SaintsHQ_Count = SaintsHQ_Count + 1
				elseif SaintsHQ_Count == 2 then
					sandboxplus_message("Saints HQ zone swapped to damaged from STAG attack")
					SaintsHQ_Count = SaintsHQ_Count + 1
				elseif SaintsHQ_Count == 3 then
					sandboxplus_message("Saints HQ zone swapped to final Saints state")
					SaintsHQ_Count = 1
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not FIVE_PUSHED then
				loren_toggle(Loren_Count)
				if Loren_Count == 1 then
					sandboxplus_message("Loren Building changed to original")
					Loren_Count = Loren_Count + 1
				elseif Loren_Count == 2 then
					sandboxplus_message("Loren Building changed to Saints intact")
					Loren_Count = Loren_Count + 1
				elseif Loren_Count == 3 then
					sandboxplus_message("Loren Building changed to Saints destroyed")
					Loren_Count = 1
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not FIVE_PUSHED then
				statue_toggle(Statue_State)
				if Statue_State == true then
					sandboxplus_message("Statue changed to destroyed")
				else
					sandboxplus_message("Statue changed to intact")
				end
				Statue_State = not Statue_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not FIVE_PUSHED then
				daedalus_toggle(Daedalus_State)
				if Daedalus_State == true then
					sandboxplus_message("Daedalus now hovering downtown")
				else
					sandboxplus_message("Daedalus removed")
				end
				Daedalus_State = not Daedalus_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not FIVE_PUSHED then
				therm_toggle(Therm_Count)
				if Therm_Count == 1 then
					sandboxplus_message("Thermopylae removed")
					Therm_Count = Therm_Count + 1
				elseif Therm_Count == 2 then
					sandboxplus_message("Thermopylae changed to intact")
					Therm_Count = Therm_Count + 1
				elseif Therm_Count == 3 then
					sandboxplus_message("Thermopylae changed to broken")
					Therm_Count = 1
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not FIVE_PUSHED then
				bridge_toggle(Bridge_State)
				if Bridge_State == true then
					sandboxplus_message("Bridges are now UP")
				else
					sandboxplus_message("Bridges are now DOWN")
				end
				Bridge_State = not Bridge_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not FIVE_PUSHED then
				zombie_toggle(Zombie_State)
				if Zombie_State == true then
					sandboxplus_message("Arapice Island changed to zombie outbreak")
				else
					sandboxplus_message("Arapice Island changed to normal")
				end
				Zombie_State = not Zombie_State
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not FIVE_PUSHED then
				stag_active_toggle(STAG_AROUND)
				if STAG_AROUND == true then
					sandboxplus_message("STAG are now active in the world")
				else
					sandboxplus_message("STAG presence has been removed")
				end
				STAG_AROUND = not STAG_AROUND
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not FIVE_PUSHED then
				set_saints_hated(HATE_THOSE_SAINTS)
				if HATE_THOSE_SAINTS == true then
					sandboxplus_message("The Saints are now hated in Steelport")
				else
					sandboxplus_message("The Saints are now loved in Steelport")
				end
				HATE_THOSE_SAINTS = not HATE_THOSE_SAINTS
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not FIVE_PUSHED then
				-- MURDERBRAWL
				murderbrawl_toggle(Murderbrawl_State)
				if Murderbrawl_State == true then
					sandboxplus_message("Murderbrawl zone loaded")
				else
					sandboxplus_message("Murderbrawl zone removed")
				end
				Murderbrawl_State = not Murderbrawl_State
				FIVE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_6") then -- Weapon Select 6 - UNUSED
			if player_action_is_pressed(B_INSERT) and not SIX_PUSHED then
				-- DECKER VR
				deckervr_toggle(DeckerVR_State)
				if DeckerVR_State == true then
					sandboxplus_message("Decker Virtual Reality zone loaded")
				else
					sandboxplus_message("Decker Virtual Reality zone removed")
				end
				DeckerVR_State = not DeckerVR_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not SIX_PUSHED then
				-- ZONE CYBERBLAZING
				cyberblazing_toggle(Cyberblazing_State)
				if Cyberblazing_State == true then
					sandboxplus_message("Cyberblazing zone loaded")
				else
					sandboxplus_message("Cyberblazing zone removed")
				end
				Cyberblazing_State = not Cyberblazing_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not SIX_PUSHED then
				-- DECKER BARGE
				barge_toggle(Barge_State)
				if Barge_State == true then
					sandboxplus_message("Decker Barge zone loaded")
				else
					sandboxplus_message("Decker Barge zone removed")
				end
				Barge_State = not Barge_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not SIX_PUSHED then
				-- HO BOAT
				hoboat_toggle(Hoboat_State)
				if Hoboat_State == true then
					sandboxplus_message("Ho Boat zone loaded")
				else
					sandboxplus_message("Ho Boat zone removed")
				end
				Hoboat_State = not Hoboat_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_END) and not SIX_PUSHED then
				-- ZONE MARS
				mars_toggle(Mars_State)
				if Mars_State == true then
					sandboxplus_message("Mars zone loaded")
				else
					sandboxplus_message("Mars zone removed")
				end
				Mars_State = not Mars_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not SIX_PUSHED then
				-- STILWATER ZONES
				stilwater_toggle(Stilwater_Count)
				if Stilwater_Count == 1 then
					sandboxplus_message("Stilwater zone and bank loaded")
					Stilwater_Count = Stilwater_Count + 1
				elseif Stilwater_Count == 2 then
					sandboxplus_message("Stilwater zone and bank damaged loaded")
					Stilwater_Count = Stilwater_Count + 1
				elseif Stilwater_Count == 3 then
					sandboxplus_message("Stilwater zone and bank removed")
					Stilwater_Count = 1
				end
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not SIX_PUSHED then
				-- ZONE LOREN JET INTERIOR
				lorenjet_toggle(LorenJet_State)
				if LorenJet_State == true then
					sandboxplus_message("Loren Jet zone loaded")
				else
					sandboxplus_message("Loren Jet zone removed")
				end
				LorenJet_State = not LorenJet_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not SIX_PUSHED then
				-- ZONE MAYOR OFFICE
				mayoroffice_toggle(MayorOffice_State)
				if MayorOffice_State == true then
					sandboxplus_message("Mayor's Office zone loaded")
				else
					sandboxplus_message("Mayor's Office zone removed")
				end
				MayorOffice_State = not MayorOffice_State
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not SIX_PUSHED then
				-- UNUSED
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not SIX_PUSHED then
				-- UNUSED
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not SIX_PUSHED then
				-- UNUSED
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not SIX_PUSHED then
				-- UNUSED
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not SIX_PUSHED then
				-- UNUSED
				SIX_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_7") then -- Weapon Select 7 - UNUSED
			if player_action_is_pressed(B_INSERT) and not SEVEN_PUSHED then
				if ZOMBIE_CHEAT then
					spawn_global_override_clear_category()
					sandboxplus_message("Zombie peds deactivated")
				else
					spawn_global_override_set_category("sp_cat_Cheat_Zombie")
					sandboxplus_message("Zombie peds activated")
				end
				ZOMBIE_CHEAT = not ZOMBIE_CHEAT
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not SEVEN_PUSHED then
				if MASCOT_CHEAT then
					spawn_global_override_clear_category()
					sandboxplus_message("Mascot peds deactivated")
				else
					spawn_global_override_set_category("sp_cat_Cheat_Mascot")
					sandboxplus_message("Mascot peds activated")
				end
				MASCOT_CHEAT = not MASCOT_CHEAT
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not SEVEN_PUSHED then
				if PIMPS_CHEAT then
					spawn_global_override_clear_category()
					sandboxplus_message("Pimps and Hos peds deactivated")
				else
					spawn_global_override_set_category("sp_cat_Cheat_Ho")
					sandboxplus_message("Pimps and Hos peds activated")
				end
				PIMPS_CHEAT = not PIMPS_CHEAT
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_END) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not SEVEN_PUSHED then
				--UNUSED
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not SEVEN_PUSHED then
				--TESTING AND TEMP CODE
				--[[--boundary trigger testing stuff
				trigger_type_enable( "warp", false)
				trigger_type_enable( "execute lua script", false)
				trigger_type_enable( "double callback", false)
				trigger_type_enable( "exploration trigger", false)
				trigger_type_enable( "console cmd execute", false)
				trigger_type_enable( "high density region", false)
				sandboxplus_message("All trigger types disabled")]]

				--[[--stumble animation testing stuff
				player_movement_disable(LOCAL_PLAYER)
				action_play(LOCAL_PLAYER, "plym drunk stumble", "", false, 1.0, true, true)
				player_movement_enable(LOCAL_PLAYER)]]


				--[[--facial expression testing stuff
				if FACE_COUNTER == 1 then
					sandboxplus_message("Expression changed to angry")
					--clear_animation_state(LOCAL_PLAYER)
					set_animation_state(LOCAL_PLAYER, "face angry")
				elseif FACE_COUNTER == 2 then
					sandboxplus_message("Expression changed to sleepy")
					--clear_animation_state(LOCAL_PLAYER)
					set_animation_state(LOCAL_PLAYER, "face sleepy")
				elseif FACE_COUNTER == 3 then
					sandboxplus_message("Expression changed to pain b")
					set_animation_state(LOCAL_PLAYER, "face pain b")
					clear_animation_state(LOCAL_PLAYER)
				elseif FACE_COUNTER == 4 then
					sandboxplus_message("Expression changed to sad")
					set_animation_state(LOCAL_PLAYER, "face sad")
					clear_animation_state(LOCAL_PLAYER)
				elseif FACE_COUNTER == 5 then
					sandboxplus_message("Expression reset to normal")
					clear_animation_state(LOCAL_PLAYER)
				end
				if FACE_COUNTER == 5 then
					FACE_COUNTER = 1
				else
					FACE_COUNTER = FACE_COUNTER + 1
				end]]

				--[[ Testing attach effects stuff
				local shock_effect_handle = effect_play( "Blood_headshot", LOCAL_PLAYER, "head" )
				local shock_effect_handle = effect_play_on_human( "vfx_electric_body", LOCAL_PLAYER, "spine2", true )
				delay( 3 )
				effect_stop( shock_effect_handle )
				sandboxplus_message("SHOCK TEST")]]
				SEVEN_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_8") then -- Weapon Select 8 - MACHINIMA, UTILITIES, AND HUD STUFF
			if player_action_is_pressed(B_INSERT) and not EIGHT_PUSHED then
				-- SHOW PLAYER POSITION
				local posx,posz,posy = get_object_pos(LOCAL_PLAYER)
				sandboxplus_message("Player Pos:".."\n".."X: "..posx .."\n".."Y: "..posy.."\n".."Z: "..posz.."\n")
				debug_print("Player Pos:".."\n".."X: "..posx .."\n".."Y: "..posy.."\n".."Z: "..posz.."\n")
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not EIGHT_PUSHED then
				-- SHOW GAMETIME
				local gametime = get_game_time()
				local timecheck_hour = gametime["hours"]
				local timecheck_min = gametime["minutes"]
				local timecheck_min_str = ""
				local ampm = ""
				if timecheck_min < 10 then -- we need to add a preceding zero so that the following concat works correctly
					timecheck_min_str = ( "0"..tostring(timecheck_min) )
				else
					timecheck_min_str = tostring(timecheck_min)
				end
				if timecheck_hour < 13 then
					ampm = "AM"
				else
					ampm = "PM"
				end
				sandboxplus_message("Gametime: "..timecheck_hour..":"..timecheck_min_str.." "..ampm.."\n")
				debug_print("Gametime: "..timecheck_hour..":"..timecheck_min_str.." "..ampm.."\n")
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not EIGHT_PUSHED then
				-- SHOW/HIDE SANDBOX+ MESSAGES
				if HUD_MSG then
					mission_help_table("Sandbox+ HUD messages turned OFF")
				else
					mission_help_table("Sandbox+ HUD messages turned ON")
				end
				HUD_MSG = not HUD_MSG
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not EIGHT_PUSHED then
				-- TUTORIAL POPUPS
				if TUTORIAL_DISABLE then
					sandboxplus_message("Tutorial Popups Enabled")
					Tutorial_Disable_Flag = false
				else
					sandboxplus_message("Tutorial Popups Disabled")
					Tutorial_Disable_Flag = true
				end
				TUTORIAL_DISABLE = not TUTORIAL_DISABLE
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not EIGHT_PUSHED then
				if PLAYER_VISIBLE then
					character_hide(LOCAL_PLAYER,false)
					sandboxplus_message("Player is now invisible")
				else
					sandboxplus_message("Player is now visible")
					character_show(LOCAL_PLAYER)
				end
				PLAYER_VISIBLE = not PLAYER_VISIBLE
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not EIGHT_PUSHED then
				if coop_is_active() then
					if not COOP_COMMANDS then
						sandboxplus_message("Special Commands now affect both host and remote player")
					else
						sandboxplus_message("Special Commands now only affect the host")
					end
					COOP_COMMANDS = not COOP_COMMANDS
				else
						sandboxplus_message("Toggle special commands for remote player FAILED")
				end				
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not EIGHT_PUSHED then
				-- UNUSED
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not EIGHT_PUSHED then
				-- UNUSED
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not EIGHT_PUSHED then
				-- UNUSED
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not EIGHT_PUSHED then
				-- UNUSED
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not EIGHT_PUSHED then
				-- UNUSED
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not EIGHT_PUSHED then
				-- UNUSED
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_SEMICOLON) and not EIGHT_PUSHED then
				if HUD_NORMAL then
					--Hide all HUD elements
					Openworld_hud_state.hide_everything = hud_display_create_state()
					hud_display_set_element(Openworld_hud_state.hide_everything, HUD_ALL_ELEM, HUD_FADE_HIDDEN)
					hud_display_commit_state(Openworld_hud_state.hide_everything)
				else
					-- Restore the HUD
					for i, hud_state in pairs(Openworld_hud_state) do
						if (hud_state ~= -1) then
							hud_display_remove_state(hud_state)
							hud_state = -1
						end
					end
					sandboxplus_message("HUD Restored")
				end
				HUD_NORMAL = not HUD_NORMAL
				EIGHT_PUSHED = true
			end
		end

		if not player_action_is_pressed("CBA_OFC_SPRINT") then
			SPRINT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_RECRUIT_DISMISS") then
			RECRUIT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_TAUNT_TWO") then
			TAUNT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_TAUNT_THREE") then
			COMPLIMENT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_CROUCH") then
			CROUCH_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_ACTION") then
			USE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_PICKUP_RELOAD") then
			RELOAD_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_MELEE_NUT_SHOT") then
			MELEE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_GRENADE_SWITCH") then
			GRENADE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_1") then
			ONE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_2") then
			TWO_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_3") then
			THREE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_4") then
			FOUR_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_5") then
			FIVE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_6") then
			SIX_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_7") then
			SEVEN_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_8") then
			EIGHT_PUSHED = false
		end

		if TUTORIAL_DISABLE then
			if (mission_is_active()) then
				Tutorial_Disable_Flag = true --This will force the tutorial_suspend_all() function to run ONCE after a mission is completed
			else
				if Tutorial_Disable_Flag then
					tutorial_suspend_all()
					Tutorial_Disable_Flag = false
				end
			end
		end

		delay(0.5)
	end
end

function tod_advance_check()

--FIX TOD TRANSITIONS
	if TOD_State then

		local gametime = get_game_time()
		local timecheck_hour = gametime["hours"]
		local timecheck_min = gametime["minutes"]
		local timecheck_min_str = ""

		--format minutes
		if timecheck_min < 10 then -- we need to add a preceding zero so that the following concat and evaluation works correctly
			timecheck_min_str = ( "0"..tostring(timecheck_min) )
		else
			timecheck_min_str = tostring(timecheck_min)
		end

		local timecheckstr = ( tostring(timecheck_hour)..timecheck_min_str )
		local timecheck = tonumber(timecheckstr) -- finally convert it back to a number for evaluation
		--debug_print("Gametime Hour: "..timecheck_hour.." Minute: "..timecheck_min.."\n")

		if timecheck >= 930 and timecheck < 1430 then
			TOD_Span = "sunrise"
		elseif timecheck >= 1430 and timecheck < 2100 then
			TOD_Span = "noon"
		elseif timecheck >= 2100 or timecheck < 500 then
			TOD_Span = "sunset"
		elseif timecheck >= 500 and timecheck < 930 then
			TOD_Span = "night"
		end


		if TOD_Last_Check == TOD_Span then
			--debug_print("TOD_Last_Check and TOD_Span are the same" .. "\n") 
		else
			debug_print("TOD_Last_Check and TOD_Span are different" .. "\n")
				if TOD_Span == "noon" then
					debug_print("set TOD to noon" .. "\n")
					set_time_of_day(14, 30) --advance TOD to noon
					TOD_Last_Check = TOD_Span
				elseif TOD_Span == "sunset" then
					debug_print("set TOD to sunset" .. "\n")
					set_time_of_day(21, 00) --advance TOD to sunset
					TOD_Last_Check = TOD_Span
				elseif TOD_Span == "night" then
					debug_print("set TOD to night" .. "\n")
					set_time_of_day(05, 00) --advance TOD to night
					TOD_Last_Check = TOD_Span
				elseif TOD_Span == "sunrise" then
					debug_print("set TOD to sunrise" .. "\n")
					set_time_of_day(09, 30) --advance TOD to sunrise
					TOD_Last_Check = TOD_Span
				end
		end
	end
end

function daedalus_toggle(state)
	city_zone_swap("daedext1", state)
	ding_finish_audio()
end

function safeword_toggle(state)
	city_zone_swap("megab1",state)
	city_zone_swap("megab2",state)
	city_zone_swap("is2",state)
	ding_finish_audio()
end

function nukeplant_toggle(state)
	city_zone_swap("nuke1",state)
	city_zone_swap("nuke2",state)
	city_zone_swap("int_sh03",state)
	city_zone_swap("int_sh03c",state)
	ding_finish_audio()
end

function threecount_toggle(state)
	city_zone_swap("3count1",state)
	city_zone_swap("3count2",state)
	city_zone_swap("int3cc",state)
	ding_finish_audio()
end

function bridge_toggle(state)
	city_zone_swap("lockdown",state)
	ding_finish_audio()
end

function statue_toggle(state)
	ding_finish_audio()
	city_zone_swap("rubble",state)
end

function zombie_toggle(state)
	city_zone_swap("chemcrash",state)
	city_zone_swap("zombies",state)
	spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", state)
	ding_finish_audio()
end

function therm_toggle(state)
	if state == 1 then -- Therm not arrived yet
		city_zone_swap("thermext1",false)
		city_zone_swap("therm2",false)
		city_zone_swap("therm3_dst",false)
	elseif state == 2 then --Therm arrives and whole
		city_zone_swap("thermext1",true) -- Thermopolye moves to south of DT
		city_zone_swap("therm2",true)
		city_zone_swap("therm3_dst",false)
	elseif state == 3 then -- Therm broken
		city_zone_swap("thermext1",false)
		city_zone_swap("therm2",false)
		city_zone_swap("therm3_dst",true)
	end
	ding_finish_audio()
end

function loren_toggle(state)
	if state == 1 then --Pre Mission 6. Interior exists
		city_zone_swap("tower_saints",false)
		city_zone_swap("tower_dmg",false)
		city_zone_swap("m6",false)
	elseif state == 2 then --Save tower
		city_zone_swap("tower_saints",true)
		city_zone_swap("tower_dmg",false)
		city_zone_swap("m6",true)		
	elseif state ==3 then --Blowup tower
		city_zone_swap("tower_saints",false)
		city_zone_swap("tower_dmg",true)
		city_zone_swap("m6",true)	
	end
	ding_finish_audio()
end

function stilwater_toggle(state)
	ding_finish_audio()
	if state == 1 then --bank intact
		city_zone_swap("stilwater",true)
		city_zone_swap("bank_destroy",false)
		city_zone_swap("bank",true)
	elseif state == 2 then --Bank damaged
		city_zone_swap("stilwater",true)
		city_zone_swap("bank",false)
		city_zone_swap("bank_destroy",true)
		
	elseif state ==3 then --Stilwater removed
		city_zone_swap("bank",false)
		city_zone_swap("bank_destroy",false)
		city_zone_swap("stilwater",false)
	end
end

function barge_toggle(state)
	ding_finish_audio()
	city_zone_swap("barge",state)
end

function hoboat_toggle(state)
	ding_finish_audio()
	city_zone_swap("cargo",state)
end

function deckervr_toggle(state)
	ding_finish_audio()
	city_zone_swap("vr",state)
end

function murderbrawl_toggle(state)
	ding_finish_audio()
	city_zone_swap("m21",state)
end

function mars_toggle(state)
	ding_finish_audio()
	city_zone_swap("Mars",state)
end

function cyberblazing_toggle(state)
	ding_finish_audio()
	city_zone_swap("vrtb",state)
end

function mayoroffice_toggle(state)
	ding_finish_audio()
	city_zone_swap("mayoroff",state)
end

function lorenjet_toggle(state)
	ding_finish_audio()
	city_zone_swap("m2",state)
	city_zone_swap("int_m2",state)
end

function saintshq_toggle(state)
	ding_finish_audio()
	if state == 1 then --Morningstar ownership
		city_zone_swap("hq_dmg", false) -- Saints HQ undamaged
		city_zone_swap( "hq", false ) -- Morningstar colors
	elseif state == 2 then --Damaged in STAG attack
		city_zone_swap("hq_dmg", true) -- Saints HQ undamaged
		city_zone_swap( "hq", false ) -- Morningstar colors
	elseif state ==3 then --Saints ownership
		city_zone_swap("hq_dmg", false) -- Saints HQ undamaged
		city_zone_swap( "hq", true ) -- Saints colors
	end
end

function stag_active_toggle(state)
	set_stag_active(state)
	set_stag_notoriety_area_active(state)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", state)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_03", state)
	city_zone_swap("stag", state)
end

function ding_finish_audio()
	if HUD_MSG then
		audio_object_post_event("WEAPON_PURCHASE", nil, nil, LOCAL_PLAYER)
	end
end


function sandboxplus_message(hud_text_msg)
	if HUD_MSG then
		mission_help_table(hud_text_msg, LOCAL_PLAYER)
	end
end

function sandbox_cutscene(cutscene)
	cutscene_play(cutscene)
	teleport_to_object(LOCAL_PLAYER, "Crib_SaintsHQ", false, nil, 0.5)
end


function add_superpowers()
	explosion_create("genki_exp", LOCAL_PLAYER)
	player_super_powered(LOCAL_PLAYER, true)
	reticle_override_set("sp_vtol01_w", "WPNCAT_RIFLE", SYNC_LOCAL)
	if COOP_COMMANDS and coop_is_active() then
		explosion_create("genki_exp", REMOTE_PLAYER)
		player_super_powered(REMOTE_PLAYER, true)
		reticle_override_set("sp_vtol01_w", "WPNCAT_RIFLE", SYNC_REMOTE)
	end
	dlc3_m03_punch_load()
	inv_weapon_add_temporary(LOCAL_PLAYER, "DLC_super_fists", 1, true, true, false, true)
	inv_item_remove("DLC_fireball", LOCAL_PLAYER)
	inv_weapon_add_temporary(LOCAL_PLAYER, "DLC_fireball", 1, true, true, false, true)
	if SUPERPOWER_SLOT_DISABLE == true then
		inv_weapon_disable_all_but_this_slot( WEAPON_SLOT_MELEE, true, SYNC_LOCAL )
	end
	auto_pickup_disable(LOCAL_PLAYER)
	if COOP_COMMANDS and coop_is_active() then
		inv_weapon_add_temporary(REMOTE_PLAYER, "DLC_super_fists", 1, true, true, false, true)
		inv_item_remove("DLC_fireball", REMOTE_PLAYER)
		inv_weapon_add_temporary(REMOTE_PLAYER, "DLC_fireball", 1, true, true, false, true)
		if SUPERPOWER_SLOT_DISABLE == true then
			inv_weapon_disable_all_but_this_slot( WEAPON_SLOT_MELEE, true, SYNC_REMOTE )
		end
		auto_pickup_disable(REMOTE_PLAYER)
	end
end

function remove_superpowers()
	player_super_powered(LOCAL_PLAYER, false)
	reticle_override_clear(SYNC_LOCAL)
	if COOP_COMMANDS and coop_is_active() then
		player_super_powered(REMOTE_PLAYER, false)
		reticle_override_clear(SYNC_REMOTE)
	end
	reticle_override_clear(SYNC_ALL)
	dlc3_m03_punch_unload()
	inv_weapon_remove_temporary(LOCAL_PLAYER, "DLC_super_fists")
	inv_weapon_remove_temporary(LOCAL_PLAYER, "DLC_fireball")
	if COOP_COMMANDS and coop_is_active() then
		inv_weapon_remove_temporary(REMOTE_PLAYER, "DLC_super_fists")
		inv_weapon_remove_temporary(REMOTE_PLAYER, "DLC_fireball")
	end
	inv_weapon_disable_all_slots(false)
	auto_pickup_enable(LOCAL_PLAYER)
	if COOP_COMMANDS and coop_is_active() then
		auto_pickup_enable(REMOTE_PLAYER)
	end
end

function get_fucking_high_bitches(scalar)
	drug_effect_set_override_values(scalar, scalar)	
	if (scalar == 1.0) then
		refraction_situation_set("drug strong")
		audio_object_post_event("sh02_drug_pitch", nil, nil, LOCAL_PLAYER)
	elseif (scalar == 0.75) then
		refraction_situation_set("drug weak")
	elseif (scalar == 0.5) then
		refraction_situation_set("drug weakest")
		audio_object_post_event("sh02_drug_pitch_50", nil, nil, LOCAL_PLAYER)
	else
		refraction_situation_clear()
		audio_object_post_event("sh02_drug_pitch_normal", nil, nil, LOCAL_PLAYER)
	end
end


-- *******************************************************************************




-- ALL FOLLOWING COOP SKIP FUNCTIONS CALLED FROM CODE (+++MUST RETURN IMMEDIATLY+++)

-- Teleport players to a mission start node
--
-- mission_name:	(string) name of the mission start node (should be same as mission name)
-- skip_teleport:	(boolean) true to basically skip this whole function, nil or not true will run it
--
function sr3_teleport_mission_start(mission_name, skip_teleport)
	if skip_teleport == nil or skip_teleport ~= true then
		-- send them to the mission start
		local vehicle_exit = true
		local offset_x = 0.5
		teleport_to_object(LOCAL_PLAYER, mission_name, vehicle_exit, nil, offset_x)
		-- remote player not on top of player
		offset_x = -0.5
		teleport_to_object(REMOTE_PLAYER, mission_name, vehicle_exit, nil, offset_x)
	end
end

function m03_coop_skip( )
	crib_purchasing_unlock( )
end

function m06_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m06", skip_teleport)
	-- Update the world state based on the choice that they made during the mission
	if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
		city_zone_swap("tower_saints")
	else
		city_zone_swap("tower_dmg")
	end
	-- kill the building interior either way
	city_zone_swap("m6")

	-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
	spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)

	if not mission_is_complete( "m07" ) then
		-- make sure we unlocked it
		mission_unlock( "m07" )
		mission_set_next_mission( "m07" )
	end
end

function m10_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m10", skip_teleport)
	set_stag_active(true)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
	
	city_zone_swap("thermext1") -- Thermopolye moves to south of DT
	city_zone_swap("therm2") -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
	city_zone_swap("stag") -- STAG shows up in DT
	traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off
end

function m13_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m13", skip_teleport)
	city_zone_swap("hq_dmg") -- HQ is damaged during this mission, swap it in
end

function m14_coop_skip( )
	-- Set Saints to be 'Hated' following this mission
	set_saints_hated(true)
end

function m17_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m17", skip_teleport)
	-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)
	
	-- Set STAG Lockdown area as immediate notoriety area
	set_stag_notoriety_area_active(true)
	
	-- Post mission swaps, Thermopolye destroyed and STAG take over downtown
	city_zone_swap("thermext1", false)
	city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
	city_zone_swap("therm3_dst")
	city_zone_swap("lockdown")
	
	-- Disable Traffic Splines Over Drawbridges
	traffic_disable_drawbridge_area(1, true)
	traffic_disable_drawbridge_area(2, true)
	traffic_disable_drawbridge_area(7, true)
	traffic_disable_drawbridge_area(8, true)
	traffic_disable_drawbridge_area(9, true)
	traffic_disable_drawbridge_area(10, true)
	traffic_disable_drawbridge_area(11, true)
	traffic_disable_drawbridge_area(12, true)
	traffic_disable_drawbridge_area(13, true)
	traffic_disable_drawbridge_area(14, true)
	traffic_disable_drawbridge_area(15, true)
	traffic_disable_drawbridge_area(16, true)
	traffic_disable_drawbridge_area(17, true)
	traffic_disable_drawbridge_area(18, true)
	traffic_disable_drawbridge_area(19, true)
	traffic_disable_drawbridge_area(20, true)
	traffic_disable_drawbridge_area(21, true)
	traffic_disable_drawbridge_area(22, true)
	traffic_disable_drawbridge_area(23, true)
	traffic_disable_drawbridge_area(24, true)
	traffic_disable_drawbridge_area(25, true)
	traffic_disable_drawbridge_area(27, true)
	traffic_disable_drawbridge_area(28, true)
	traffic_disable_drawbridge_area(29, true)
	traffic_disable_drawbridge_area(30, true)
	traffic_disable_drawbridge_area(31, true)
	traffic_disable_drawbridge_area(32, true)
	traffic_disable_drawbridge_area(33, true)
end

function m18_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m18", skip_teleport)
	-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
	spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)
	
	-- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled'
	traffic_disable_drawbridge_area(3, true)
	traffic_disable_drawbridge_area(4, true)
	traffic_disable_drawbridge_area(5, true)
	traffic_disable_drawbridge_area(6, true)
	traffic_disable_drawbridge_area(26, true)
	
	-- Swap the Zombie zone
	city_zone_swap("chemcrash")
	city_zone_swap("zombies")
end

function m22_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m22", skip_teleport)
	if game_choice_get_state( MISSION_22_CHOICE ) == M22_CHOICE_KILLBANE_KILL then
		mission_unlock( "m23" )
		city_zone_swap("rubble") -- Player went for Killbane, statue got blowed up
	else
		mission_unlock( "m24" )
	end
end

function m23_m24_coop_skip(skip_teleport)
	sr3_teleport_mission_start("m23", skip_teleport)
	
	-- Set STAG Inactive
	set_stag_active(false)
	
	-- Remove Lockdown Spawning from Downtown Hoods
	spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
	spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)
	
	-- Set Traffic to Be Enabled Across Lockdown Drawbridges Again
	traffic_disable_drawbridge_area(7, false)
	traffic_disable_drawbridge_area(8, false)
	traffic_disable_drawbridge_area(9, false)
	traffic_disable_drawbridge_area(10, false)
	traffic_disable_drawbridge_area(11, false)
	traffic_disable_drawbridge_area(12, false)
	traffic_disable_drawbridge_area(13, false)
	traffic_disable_drawbridge_area(14, false)
	traffic_disable_drawbridge_area(15, false)
	traffic_disable_drawbridge_area(16, false)
	traffic_disable_drawbridge_area(17, false)
	traffic_disable_drawbridge_area(18, false)
	traffic_disable_drawbridge_area(19, false)
	traffic_disable_drawbridge_area(20, false)
	traffic_disable_drawbridge_area(21, false)
	traffic_disable_drawbridge_area(22, false)
	traffic_disable_drawbridge_area(23, false)
	traffic_disable_drawbridge_area(24, false)
	traffic_disable_drawbridge_area(25, false)
	traffic_disable_drawbridge_area(27, false)
	traffic_disable_drawbridge_area(28, false)
	traffic_disable_drawbridge_area(29, false)
	traffic_disable_drawbridge_area(30, false)
	traffic_disable_drawbridge_area(31, false)
	traffic_disable_drawbridge_area(32, false)
	traffic_disable_drawbridge_area(33, false)
	traffic_disable_drawbridge_area(34, false)
	
	-- Disable Downtown Notoriety Areas
	set_stag_notoriety_area_active(false)
	
	-- Set Saints to be beloved again
	set_saints_hated(false)
	
	-- Perform zone swaps
	city_zone_swap("hq_dmg", DISABLE) -- restore saints HQ
	city_zone_swap( "hq", true )
	
	-- Maybe allow you to play through again
	mission_maybe_uncomplete_m22()
end

function sh02_coop_skip(skip_teleport)
	sr3_teleport_mission_start("sh02", skip_teleport)
	crib_unlock_strongold("Crib_BDSM")
end

function sh03_coop_skip(skip_teleport)
	sr3_teleport_mission_start("sh03", skip_teleport)
	crib_unlock_strongold("Crib_Nuke")
end

function sh04_coop_skip(skip_teleport)
	sr3_teleport_mission_start("sh04", skip_teleport)
	crib_unlock_strongold("Crib_3Count")
end

function world_state_magic(mission_num)

	debug_print("Start world_state_magic")

	-- This new function completely changes world state depending on which set of missions are replayed
	
	if mission_num == "m01_05" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic to Be Enabled Across Lockdown Drawbridges Again
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, false)


		----------- m06 STUFF --------------

		-- Restore interiors for loren's building
		city_zone_swap("m6", false)
 
		--Disable Saints Tower choice
		city_zone_swap("tower_saints", false)
 
		--Disable damaged tower choice
		city_zone_swap("tower_dmg", false)
 
		-- Set Hood ('Henry Steel Mills') to NOT Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", false)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be loved
		set_saints_hated(false)

		-- Set STAG Inactive
		set_stag_active(false)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		-- Restore damaged Saints HQ from STAG attack
		city_zone_swap("hq_dmg", false) -- restore Saints HQ undamaged
		city_zone_swap( "hq", false ) -- revert to Morningstar colors
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false)
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)
		city_zone_swap("stag", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

	elseif mission_num == "m06" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic to Be Enabled Across Lockdown Drawbridges Again
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, false)


		----------- m06 STUFF --------------

		-- Restore interiors for loren's building
		city_zone_swap("m6", false)
 
		--Disable Saints Tower choice
		city_zone_swap("tower_saints", false)
 
		--Disable damaged tower choice
		city_zone_swap("tower_dmg", false)
 
		-- Set Hood ('Henry Steel Mills') to NOT Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", false)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be loved
		set_saints_hated(false)

		-- Set STAG Inactive
		set_stag_active(false)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		-- Restore damaged Saints HQ from STAG attack
		city_zone_swap("hq_dmg", false) -- restore saints HQ undamaged
		city_zone_swap( "hq", true ) -- restore Saints HQ colors
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false)
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)
		city_zone_swap("stag", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

	elseif mission_num == "m07_10" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic to Be Enabled Across Lockdown Drawbridges Again
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, false)


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be loved
		set_saints_hated(false)

		-- Set STAG Inactive
		set_stag_active(false)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		-- Restore damaged Saints HQ from STAG attack
		city_zone_swap("hq_dmg", false) -- restore saints HQ undamaged
		city_zone_swap( "hq", true ) -- restore Saints HQ colors
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false)
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)
		city_zone_swap("stag", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

	elseif mission_num == "sh02" then --Pimp Up Hos Down Stronghold

		----------- BRIDGE STUFF --------------

		-- Set Traffic to Be Enabled Across Lockdown Drawbridges Again
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, false)


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be loved
		set_saints_hated(false)

		-- Set STAG Inactive
		set_stag_active(false)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		-- Restore damaged Saints HQ from STAG attack
		city_zone_swap("hq_dmg", false) -- restore saints HQ undamaged
		city_zone_swap( "hq", true ) -- restore Saints HQ colors
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false)
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)
		city_zone_swap("stag", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

		debug_print("world state -sh02- complete")

	elseif mission_num == "m11_13" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be loved
		set_saints_hated(false)

		-- Set STAG Active
		set_stag_active(true)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Enable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)

		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		-- Restore damaged Saints HQ from STAG attack
		city_zone_swap("hq_dmg", false) -- restore saints HQ undamaged
		city_zone_swap( "hq", true ) -- restore Saints HQ colors
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1") -- Thermopolye moves to south of DT
		city_zone_swap("therm2") -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("stag") -- STAG shows up in DT
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

		debug_print("world state -m11_13- complete")

	elseif mission_num == "m14" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be loved
		set_saints_hated(false)

		-- Set STAG Active
		set_stag_active(true)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Enable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)

		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		city_zone_swap("hq_dmg") -- HQ is damaged during the last mission, swap it in
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1") -- Thermopolye moves to south of DT
		city_zone_swap("therm2") -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("stag") -- STAG shows up in DT
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

		debug_print("world state -m14- complete")


	elseif mission_num == "m15_17" then


		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Enable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)

		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1") -- Thermopolye moves to south of DT
		city_zone_swap("therm2") -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("stag") -- STAG shows up in DT
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

	elseif mission_num == "sh03" then -- Stop All the Downloading stronghold Deckers Nuke Plant


		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, false)
		traffic_disable_drawbridge_area(2, false)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Disable Downtown STAG Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Enable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)

		-- Disable STAG Lockdown
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Disable Stag zone stuff
		city_zone_swap("thermext1") -- Thermopolye moves to south of DT
		city_zone_swap("therm2") -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("stag") -- STAG shows up in DT
		city_zone_swap("therm3_dst", false)
		city_zone_swap("lockdown", false)

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

		debug_print("world state -sh03- complete")


	elseif mission_num == "m18" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, false)
		traffic_disable_drawbridge_area(4, false)
		traffic_disable_drawbridge_area(5, false)
		traffic_disable_drawbridge_area(6, false)
		traffic_disable_drawbridge_area(7, true)
		traffic_disable_drawbridge_area(8, true)
		traffic_disable_drawbridge_area(9, true)
		traffic_disable_drawbridge_area(10, true)
		traffic_disable_drawbridge_area(11, true)
		traffic_disable_drawbridge_area(12, true)
		traffic_disable_drawbridge_area(13, true)
		traffic_disable_drawbridge_area(14, true)
		traffic_disable_drawbridge_area(15, true)
		traffic_disable_drawbridge_area(16, true)
		traffic_disable_drawbridge_area(17, true)
		traffic_disable_drawbridge_area(18, true)
		traffic_disable_drawbridge_area(19, true)
		traffic_disable_drawbridge_area(20, true)
		traffic_disable_drawbridge_area(21, true)
		traffic_disable_drawbridge_area(22, true)
		traffic_disable_drawbridge_area(23, true)
		traffic_disable_drawbridge_area(24, true)
		traffic_disable_drawbridge_area(25, true)
		traffic_disable_drawbridge_area(26, false)
		traffic_disable_drawbridge_area(27, true)
		traffic_disable_drawbridge_area(28, true)
		traffic_disable_drawbridge_area(29, true)
		traffic_disable_drawbridge_area(30, true)
		traffic_disable_drawbridge_area(31, true)
		traffic_disable_drawbridge_area(32, true)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to remove Zombies
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", false)

		-- Disable all the zombie zone stuff
		city_zone_swap("chemcrash", false)
		city_zone_swap("zombies", false)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Set STAG Lockdown area as immediate notoriety area
		set_stag_notoriety_area_active(true)
 
		-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		-- Statue is not blowed up
		city_zone_swap("rubble", false)

		debug_print("world state -m18- complete")

	elseif mission_num == "m19" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(4, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(5, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(6, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(7, true)
		traffic_disable_drawbridge_area(8, true)
		traffic_disable_drawbridge_area(9, true)
		traffic_disable_drawbridge_area(10, true)
		traffic_disable_drawbridge_area(11, true)
		traffic_disable_drawbridge_area(12, true)
		traffic_disable_drawbridge_area(13, true)
		traffic_disable_drawbridge_area(14, true)
		traffic_disable_drawbridge_area(15, true)
		traffic_disable_drawbridge_area(16, true)
		traffic_disable_drawbridge_area(17, true)
		traffic_disable_drawbridge_area(18, true)
		traffic_disable_drawbridge_area(19, true)
		traffic_disable_drawbridge_area(20, true)
		traffic_disable_drawbridge_area(21, true)
		traffic_disable_drawbridge_area(22, true)
		traffic_disable_drawbridge_area(23, true)
		traffic_disable_drawbridge_area(24, true)
		traffic_disable_drawbridge_area(25, true)
		traffic_disable_drawbridge_area(26, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(27, true)
		traffic_disable_drawbridge_area(28, true)
		traffic_disable_drawbridge_area(29, true)
		traffic_disable_drawbridge_area(30, true)
		traffic_disable_drawbridge_area(31, true)
		traffic_disable_drawbridge_area(32, true)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Set STAG Lockdown area as immediate notoriety area
		set_stag_notoriety_area_active(true)
 
		-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		-- Statue is not blowed up
		city_zone_swap("rubble", false)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)

		-- Swap the Zombie zone
		city_zone_swap("chemcrash")
		city_zone_swap("zombies")

		debug_print("world state -m19- complete")


	elseif mission_num == "sh04" then -- 3 Count Beatdown Stronghold

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(4, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(5, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(6, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(7, true)
		traffic_disable_drawbridge_area(8, true)
		traffic_disable_drawbridge_area(9, true)
		traffic_disable_drawbridge_area(10, true)
		traffic_disable_drawbridge_area(11, true)
		traffic_disable_drawbridge_area(12, true)
		traffic_disable_drawbridge_area(13, true)
		traffic_disable_drawbridge_area(14, true)
		traffic_disable_drawbridge_area(15, true)
		traffic_disable_drawbridge_area(16, true)
		traffic_disable_drawbridge_area(17, true)
		traffic_disable_drawbridge_area(18, true)
		traffic_disable_drawbridge_area(19, true)
		traffic_disable_drawbridge_area(20, true)
		traffic_disable_drawbridge_area(21, true)
		traffic_disable_drawbridge_area(22, true)
		traffic_disable_drawbridge_area(23, true)
		traffic_disable_drawbridge_area(24, true)
		traffic_disable_drawbridge_area(25, true)
		traffic_disable_drawbridge_area(26, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(27, true)
		traffic_disable_drawbridge_area(28, true)
		traffic_disable_drawbridge_area(29, true)
		traffic_disable_drawbridge_area(30, true)
		traffic_disable_drawbridge_area(31, true)
		traffic_disable_drawbridge_area(32, true)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Set STAG Lockdown area as immediate notoriety area
		set_stag_notoriety_area_active(true)
 
		-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		-- Statue is not blowed up
		city_zone_swap("rubble", false)


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)

		-- Swap the Zombie zone
		city_zone_swap("chemcrash")
		city_zone_swap("zombies")

		debug_print("world state -sh04- complete")


	elseif mission_num == "m20" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(4, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(5, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(6, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(7, true)
		traffic_disable_drawbridge_area(8, true)
		traffic_disable_drawbridge_area(9, true)
		traffic_disable_drawbridge_area(10, true)
		traffic_disable_drawbridge_area(11, true)
		traffic_disable_drawbridge_area(12, true)
		traffic_disable_drawbridge_area(13, true)
		traffic_disable_drawbridge_area(14, true)
		traffic_disable_drawbridge_area(15, true)
		traffic_disable_drawbridge_area(16, true)
		traffic_disable_drawbridge_area(17, true)
		traffic_disable_drawbridge_area(18, true)
		traffic_disable_drawbridge_area(19, true)
		traffic_disable_drawbridge_area(20, true)
		traffic_disable_drawbridge_area(21, true)
		traffic_disable_drawbridge_area(22, true)
		traffic_disable_drawbridge_area(23, true)
		traffic_disable_drawbridge_area(24, true)
		traffic_disable_drawbridge_area(25, true)
		traffic_disable_drawbridge_area(26, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(27, true)
		traffic_disable_drawbridge_area(28, true)
		traffic_disable_drawbridge_area(29, true)
		traffic_disable_drawbridge_area(30, true)
		traffic_disable_drawbridge_area(31, true)
		traffic_disable_drawbridge_area(32, true)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Set STAG Lockdown area as immediate notoriety area
		set_stag_notoriety_area_active(true)
 
		-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		if game_choice_get_state( MISSION_22_CHOICE ) == M22_CHOICE_KILLBANE_KILL then
			city_zone_swap("rubble") -- Player went for Killbane, statue got blowed up
		else
			city_zone_swap("rubble", false) -- Statue saved
		end


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)

		-- Swap the Zombie zone
		city_zone_swap("chemcrash")
		city_zone_swap("zombies")

		debug_print("world state -m20- complete")


	elseif mission_num == "m21_22" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(4, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(5, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(6, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(7, true)
		traffic_disable_drawbridge_area(8, true)
		traffic_disable_drawbridge_area(9, true)
		traffic_disable_drawbridge_area(10, true)
		traffic_disable_drawbridge_area(11, true)
		traffic_disable_drawbridge_area(12, true)
		traffic_disable_drawbridge_area(13, true)
		traffic_disable_drawbridge_area(14, true)
		traffic_disable_drawbridge_area(15, true)
		traffic_disable_drawbridge_area(16, true)
		traffic_disable_drawbridge_area(17, true)
		traffic_disable_drawbridge_area(18, true)
		traffic_disable_drawbridge_area(19, true)
		traffic_disable_drawbridge_area(20, true)
		traffic_disable_drawbridge_area(21, true)
		traffic_disable_drawbridge_area(22, true)
		traffic_disable_drawbridge_area(23, true)
		traffic_disable_drawbridge_area(24, true)
		traffic_disable_drawbridge_area(25, true)
		traffic_disable_drawbridge_area(26, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(27, true)
		traffic_disable_drawbridge_area(28, true)
		traffic_disable_drawbridge_area(29, true)
		traffic_disable_drawbridge_area(30, true)
		traffic_disable_drawbridge_area(31, true)
		traffic_disable_drawbridge_area(32, true)
		traffic_disable_drawbridge_area(34, true) -- Disables splines on road through Sunset Park that STAG cordons off


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		----------- STAG STUFF --------------

		-- Set Saints to be hated
		set_saints_hated(true)

		-- Set STAG Active
		set_stag_active(true)

		-- Set STAG Lockdown area as immediate notoriety area
		set_stag_notoriety_area_active(true)
 
		-- Set STAG Lockdown spawning for downtown hoods to True (Hood DT_02 still missing change, waiting on Chris N. solution to having two alternate spawn groups)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", true)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", true)

		city_zone_swap("hq_dmg") -- HQ is damaged
		city_zone_swap( "hq", false ) -- Not sure why m13 swaps this zone in with previous morningstar colors, but added anyway just in case
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		if game_choice_get_state( MISSION_22_CHOICE ) == M22_CHOICE_KILLBANE_KILL then
			city_zone_swap("rubble") -- Player went for Killbane, statue got blowed up
		else
			city_zone_swap("rubble", false) -- Statue saved
		end


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)

		-- Swap the Zombie zone
		city_zone_swap("chemcrash")
		city_zone_swap("zombies")

		debug_print("world state -m21_22- complete")


	elseif mission_num == "m23" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(4, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(5, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(6, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, false)


		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		----------- STAG STUFF --------------

		-- Set Saints to be loved again
		set_saints_hated(false)

		-- Set STAG Inactive
		set_stag_active(false)

		-- Disable Downtown Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Remove Lockdown Spawning from Downtown Hoods
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		city_zone_swap("hq_dmg", DISABLE) -- restore saints HQ
		city_zone_swap( "hq", true ) -- restore Saints color schemes
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		if game_choice_get_state( MISSION_22_CHOICE ) == M22_CHOICE_KILLBANE_KILL then
			city_zone_swap("rubble") -- Player went for Killbane, statue got blowed up
		else
			city_zone_swap("rubble", false) -- Statue saved
		end


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)

		-- Swap the Zombie zone
		city_zone_swap("chemcrash")
		city_zone_swap("zombies")

		debug_print("world state -m23- complete")


	elseif mission_num == "final" then

		----------- BRIDGE STUFF --------------

		-- Set Traffic Status Across Lockdown Drawbridges
		traffic_disable_drawbridge_area(1, true)
		traffic_disable_drawbridge_area(2, true)
		traffic_disable_drawbridge_area(3, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(4, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(5, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(6, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(7, false)
		traffic_disable_drawbridge_area(8, false)
		traffic_disable_drawbridge_area(9, false)
		traffic_disable_drawbridge_area(10, false)
		traffic_disable_drawbridge_area(11, false)
		traffic_disable_drawbridge_area(12, false)
		traffic_disable_drawbridge_area(13, false)
		traffic_disable_drawbridge_area(14, false)
		traffic_disable_drawbridge_area(15, false)
		traffic_disable_drawbridge_area(16, false)
		traffic_disable_drawbridge_area(17, false)
		traffic_disable_drawbridge_area(18, false)
		traffic_disable_drawbridge_area(19, false)
		traffic_disable_drawbridge_area(20, false)
		traffic_disable_drawbridge_area(21, false)
		traffic_disable_drawbridge_area(22, false)
		traffic_disable_drawbridge_area(23, false)
		traffic_disable_drawbridge_area(24, false)
		traffic_disable_drawbridge_area(25, false)
		traffic_disable_drawbridge_area(26, true) -- Set Drawbridge Traffic Splines to Arapice Island as 'Disabled' for zombies
		traffic_disable_drawbridge_area(27, false)
		traffic_disable_drawbridge_area(28, false)
		traffic_disable_drawbridge_area(29, false)
		traffic_disable_drawbridge_area(30, false)
		traffic_disable_drawbridge_area(31, false)
		traffic_disable_drawbridge_area(32, false)
		traffic_disable_drawbridge_area(33, false)
		traffic_disable_drawbridge_area(34, false)

		----------- m06 STUFF --------------

		if game_choice_get_state( MISSION_06_CHOICE ) == M06_CHOICE_BRANDED_TOWER then
			city_zone_swap("tower_saints")
		else
			city_zone_swap("tower_dmg")
		end
		-- kill the building interior either way
		city_zone_swap("m6")

		-- Set Hood ('Henry Steel Mills') to Spawn THE BALL from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_DT_01", true)


		----------- STAG STUFF --------------

		-- Set Saints to be loved again
		set_saints_hated(false)

		-- Set STAG Inactive
		set_stag_active(false)

		-- Disable Downtown Notoriety Areas
		set_stag_notoriety_area_active(false)
 
		-- Remove Lockdown Spawning from Downtown Hoods
		spawn_override_change_hood_alternate_spawning("HOOD_DT_02", false)
		spawn_override_change_hood_alternate_spawning("HOOD_DT_03", false)

		city_zone_swap("hq_dmg", DISABLE) -- restore saints HQ
		city_zone_swap( "hq", true ) -- restore saints color scheme
 
		-- Enable Stag zone stuff
		city_zone_swap("thermext1", false)
		city_zone_swap("therm2", false) -- This swap just the interior trigger and volume for thermext1.  Those two should be consolidated.
		city_zone_swap("therm3_dst")
		city_zone_swap("lockdown")
		city_zone_swap("stag") -- STAG shows up in DT

		if game_choice_get_state( MISSION_22_CHOICE ) == M22_CHOICE_KILLBANE_KILL then
			city_zone_swap("rubble") -- Player went for Killbane, statue got blowed up
		else
			city_zone_swap("rubble", false) -- Statue saved
		end


		---------- ZOMBIE STUFF -------------

		-- Set Hood ('Arapice Island') to Spawn Zombies from now on as ambient
		spawn_override_change_hood_alternate_spawning("HOOD_ZOMBIE", true)

		-- Swap the Zombie zone
		city_zone_swap("chemcrash")
		city_zone_swap("zombies")

	end
end

function stronghold_magic(sh_name,sh_state)

	-- Swap stronghold crib zones from original to Saints cribs and back - called from mission scripts
	-- sh_state = true swaps to saints crib, sh_state = false is original gang controlled

	if sh_name == "safeword" then
		-- Swap zones for BDSM Safeword
		city_zone_swap("megab1",sh_state)
		city_zone_swap("megab2",sh_state)
		city_zone_swap("is2",sh_state)
	elseif sh_name == "nuke" then
		-- Swap Zones for Decker nuke plant
		city_zone_swap("nuke1",sh_state)
		city_zone_swap("nuke2",sh_state)
		city_zone_swap("int_sh03",sh_state)
		city_zone_swap("int_sh03c",sh_state)
	elseif sh_name == "3count" then
		-- Swap Zones for 3 Count Casino
		city_zone_swap("3count1",sh_state)
		city_zone_swap("3count2",sh_state)
		city_zone_swap("int3cc",sh_state)
	end
end